#|
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
|#
(%define-glue (apply)
{
unsigned i, n;
obj proc;

    COUNT_ARGS_AT_LEAST(2);
    proc = REG0;
    
    n = expand_last() - 1;
    
    /* shift the registers, because we are removing the
       'proc' arg from REG0
       (might want to optimize this for smaller n's...) */
    
    for (i=0; i<n; i++)
	reg_set( i, reg_ref(i+1) );

    APPLY( n, proc );
})

; APPLY* is analagous to apply, but is substantially
; more efficient because the arguments don't have to be shifted
; (it takes the procedure argument as it's last argument,
;  rather than it's first)

(%define-glue (apply*)
{
unsigned n;
obj proc;

    COUNT_ARGS_AT_LEAST(2);

    proc = reg_ref( --arg_count_reg );
    n = expand_last();
    
    APPLY( n, proc );
})

;; APPLY-WITHIN-DYNAMIC-STATE calls another function
;; with it's own arguments, but within a new dynamic
;; state (as specified by the last argument).  The
;; function to be called is the next-to-the-last argument.
;; (these two arguments are stripped from the call
;;  to the function.  However, the last one is NOT expanded
;;  as by apply*)

(%define-glue (apply-within-dynamic-state)
{
obj proc;

    COUNT_ARGS_AT_LEAST(2);
    dynamic_state_reg = reg_ref( --arg_count_reg );
    proc = reg_ref( --arg_count_reg );
    
    APPLY( arg_count_reg, proc );
})

(%define-glue (list->values)
{
unsigned n;

    n = expand_last();
    RETURN(n);
})

(%define-glue %continuer
{
    continuation_reg = LEXREF0(0);
    if (arg_count_reg == 0)
	RETURN0();
    else
	RETURN(arg_count_reg);
})

(%define-glue (call-with-current-continuation) literals: ((& %continuer))
{
obj proc = REG0;

    COUNT_ARGS(1);
    flush_stack_cache();	/* flush the stack cache, if any */
    BIND1( continuation_reg );
    REG0 = make_closure( envt_reg, TLREF(0) /* %continuer */ );
    APPLY( 1, proc );
})

(define (procedure? thing)
    (%call ("CLOSURE_P" (<obj>) => <raw-bool>) thing))

(define root: "procedure_template" %procedure (%template (ctcprims 1097) 4))
(define root: "ctc_template" %ctc-template (%template (ctcprims 1097) 15 '()))

(define (make-ctc-template body)
    (%make <Template> (%gvec-read %ctc-template 0)
		      (%gvec-read %ctc-template 1)
		      body))

(export %procedure %ctc-template procedure? 
	make-ctc-template
	apply apply* list->values 
	call-with-current-continuation
	apply-within-dynamic-state)
