#|
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
|#
(prologue {
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "runtim.h"
})

(snarf define-primop-rewriter)

(define-rewriter (define-primop form)
    (define-primop-rewriter form))
    
(snarf scheme-error-rewriter)
(define-rewriter (scheme-error form)
    (scheme-error-rewriter form))

(export scheme-error)

;; ezcmp knows about a TLV by this name in the first module
;; when it's saving an image.  It gets set to the initialization
;; thunk <vector>

(define *initialization-thunks* #f)

;; make it available to everyone else
;; (and make sure they see the right answer AFTER the compiler
;;  fills it in)
(export (*initialization-thunks* :shared))

(load "macros.scm")
(load "alloc.scm")
(load "iohooks.scm")
(load "../bob2/bob2.scm")

(load "eq.scm")
(load "pairs.scm")
(load "vector.scm")
(load "strings.scm")
(load "immobs.scm")
(load "bvec.scm")

(load "apply.scm")
(load "arith.scm")
(load "excepts.scm")

(load "../scmlib/scmlib.scm")
(load "seq.scm")

;(load "../hasht/hasht.scm")
(load "../heapi/heapi.scm")
;; (load "time.scm")

;;(load "../bnchmark/fast.scm")


