#|
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
|#
#|
(define-syntax cons (syntax-form (car cdr)
    (%call ("cons" (<obj> <obj>) => <obj>) car cdr)))

(define-syntax null? (syntax-form (x)
    (%call ("NULL_P" (<obj>) => <raw-bool>) x)))

(define-syntax pair? (syntax-form (x)
    (%call ("PAIR_P" (<obj>) => <raw-bool>) x)))
|#
(define-primop (cons a b)
    (%call ("cons" (<obj> <obj>) => <obj>) a b))

(define-primop (pair? thing)
    (%call ("PAIR_P" (<obj>) => <raw-bool>) thing))

(define-primop (null? thing)
    (%call ("NULL_P" (<obj>) => <raw-bool>) thing))

#|
Will this work..? (cognated 94.06.22)
|#

(define-primop (car arg)
  (let ((x arg))
    (if (pair? x)
	(%call ("pair_car" (<obj>) => <obj>) x)
	(begin
	  (%call ("failed_type_check" (<obj> <obj> <obj> <obj>))
		 'car 'arg x <pair>)
	  0))))

#|
(define-syntax car (syntax-form (x)
    (%call ("pair_car" (<obj>) => <obj>) x)))
|#

(define-syntax cdr (syntax-form (x)
    (%call ("pair_cdr" (<obj>) => <obj>) x)))

(define-shadow cons cons)
(define-shadow car car)
(define-shadow cdr cdr)
(define-shadow null? null?)
(define-shadow pair? pair?)


(define-syntax list
    (syntax-form (item . more-items) 
    			(cons item (list . more-items)))
    (syntax-form () '()))

(define-syntax %list (syntax-form items (list . items)))

(define-shadow list list)	;; not actually necessary

(export %list
	(car %car)
	(cdr %cdr)
	null? pair? cons)
#|
(export	(null? %null?)
	(pair? %pair?)
	(cons %cons))
|#


