#|
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
|#

(define-macro (%gvec-length thing)
    (%call ("SIZEOF_PTR" (<obj>) => <raw-int-bytes>) thing))
	
(define-macro (%gvec-read thing index)
    (%call ("gvec_read" (<obj> <raw-int-bytes>) => <obj>) 
	    thing 
	    index))

(define-macro (%gvec-write thing index value)
    (%call ("gvec_write" (<obj> <raw-int-bytes> <obj>)) 
	    thing 
	    index 
	    value))

(%define-glue (clone from) literals: ("clone: ~s not a heap object")
{
obj the_class, newobj;
UINT_32 length, i;

    if (OBJ_ISA_PTR(from))
    {
	the_class = CLASSOF_PTR(from);
	length = SIZEOF_PTR(from);
	
	if (EQ(gvec_read( the_class, SLOT(1) ), FALSE_OBJ ))
	{
	    /* gvec */
	    newobj = alloc( length, the_class );
	    for (i=0; i<length; i+=SLOT(1))
		gvec_write_fresh( newobj, i, gvec_read( from, i ) );
	}
	else
	{
	    /* bvec */
	    newobj = bvec_alloc( length, the_class );
	    memcpy( PTR_TO_DATAPTR(newobj), PTR_TO_DATAPTR(from), length );
	}
	REG0 = newobj;
    }
    else
    {
	/* not a heap object */
	scheme_error( string_text(LITERAL(0)), 1, from );
    }
    RETURN(1);
})

(define (_%gvec-length item)
    (assert (gvec? item))
    (%gvec-length item))
    
(define (_%gvec-read item index)
    (assert (gvec? item))
    (assert (>= index 0))
    (assert (< index (%gvec-length item)))
    (%gvec-read item index))
    
(define (_%gvec-write item index value)
    (assert (gvec? item))
    (assert (>= index 0))
    (assert (< index (%gvec-length item)))
    (let ((old (%gvec-read item index)))
	(%gvec-write item index value)
	old))

    
(define-shadow %gvec-length %gvec-length)
(define-shadow %gvec-read %gvec-read)
(define-shadow %gvec-write %gvec-write)

(export %gvec-length %gvec-read %gvec-write clone)

(export _%gvec-length _%gvec-read _%gvec-write)
