#|
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
|#
(define-class <seq> (<Object>) :no-ivar-gfs first last)

(define-method initialize ((self <seq>))
    (let ((i (cons 0 '())))
	(%gvec-write self 0 i)
	(%gvec-write self 1 i)
	self))

(define-primop (seq? thing)
    (isa-ptr? thing directly: <seq>))
    
(define-primop (make-seq)
    (let ((i (cons 0 '())))
	(%make <seq> i i)))

(define-primop (seq-add! (seq <seq>) item)
    (let* ((the-item item)
           (i (cons the-item '())))
	(set-cdr! (%gvec-read seq 1) i)
	(%gvec-write seq 1 i)
	the-item))

(define-primop (seq->list (seq <seq>))
    (cdr (%gvec-read seq 0)))

(define-primop (seq-empty? (seq <seq>))
    (null? (cdr (%gvec-read seq 0))))


(define (select pred l)
  (let ((r (make-seq)))
    (let loop ((s l))
      (if (pair? s)
	  (begin
	    (if (pred (car s))
		(seq-add! r (car s)))
	    (loop (cdr s)))
	  (seq->list r)))))

(define (range n)
    (type-check n fixnum? <FixNum>)
    (assert (>= n 0))
    (let loop ((i (sub1 n)) (r '()))
	(if (eq? i -1)
	    r
	    (loop (sub1 i) (cons i r)))))

(export <seq> seq? make-seq seq-add! seq->list seq-empty?
	select range)

