#|
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
|#
(prologue {
#include "scmtime.h"
})

(include-c "scmtime.c")
(include-h "scmtime.h")

(define-class <Time> (<Object>) 
	      image-mode: 7)

(define-class <Interval> (<Object>) 
	      image-mode: 7)

(%define-glue (time-now) literals: ((& <Time>))
{
struct scheme_time t;

    t.sec = 
    t.usec = 0;
    REG0 = make_time( t, TLREF(0) );
    RETURN(1);
})

(%define-glue (time+ base_time interval) literals: ((& <Time>))
{
struct scheme_time t = timeadd( base_time, interval );

    REG0 = make_time( t, TLREF(0) );
    RETURN(1);
})


(export <Time> <Interval>)
(export time-now time+)
