/*
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
*/
#include "bltin_p.h"

/* Link file for the bltin module */

#define NUM_ROOTS (27)
obj bltin_root_vector[NUM_ROOTS];

#ifdef PROVIDE_ROOT_NAMES
static struct root_info roots[] = {
    { 0, "%boot-list" },
    { 7, "<pair>" },
    { 6, "<string>" },
    { 5, "<vector>" },
    { 4, "<closure>" },
    { 3, "<bindingenvt>" },
    { 2, "<symbol>" },
    { 1, "<<class>>" },
    { 12, "<template>" },
    { 11, "<toplevelvar>" },
    { 10, "<toplevelenvt>" },
    { 9, "<double-float>" },
    { 8, "<fixnum>" },
    { 20, "<uniqueobject>" },
    { 19, "<unicode-char>" },
    { 18, "<ascii-char>" },
    { 17, "<null>" },
    { 16, "<boolean>" },
    { 15, "<partialcontinuation>" },
    { 14, "<c-text>" },
    { 13, "<bytevector>" },
    { 22, "%ctc-template" },
    { 21, "%procedure" },
    { 26, "%exception-handler" },
    { 25, "%interrupt-handler" },
    { 24, "$continue-intr-tmpl" },
    { 23, "$finish-run-tmpl" },
    { 0, NULL } };
#else /* PROVIDE_ROOT_NAMES */
#define roots ((struct root_info *)0)
#endif /* PROVIDE_ROOT_NAMES */
extern struct part_descr bltin_part_car_cdr;
extern struct part_descr bltin_part_rewrite;
extern struct part_descr bltin_part_miscmac;
extern struct part_descr bltin_part_inlines;
extern struct part_descr bltin_part_gvec;
extern struct part_descr bltin_part_alloc;
extern struct part_descr bltin_part_iohooks;
extern struct part_descr bltin_part_rw_igfs2;
extern struct part_descr bltin_part_rw_igfs1;
extern struct part_descr bltin_part_rw_igfs;
extern struct part_descr bltin_part_fielders;
extern struct part_descr bltin_part_typesys;
extern struct part_descr bltin_part_class;
extern struct part_descr bltin_part_fastgfs;
extern struct part_descr bltin_part_bootclsb;
extern struct part_descr bltin_part_object;
extern struct part_descr bltin_part_gfs;
extern struct part_descr bltin_part_eq;
extern struct part_descr bltin_part_pairs2;
extern struct part_descr bltin_part_pairs1;
extern struct part_descr bltin_part_pairs;
extern struct part_descr bltin_part_vector;
extern struct part_descr bltin_part_strings;
extern struct part_descr bltin_part_immobs1;
extern struct part_descr bltin_part_immobs;
extern struct part_descr bltin_part_bvec;
extern struct part_descr bltin_part_apply;
extern struct part_descr bltin_part_arith;
extern struct part_descr bltin_part_excepts;
extern struct part_descr bltin_part_quasiq;
extern struct part_descr bltin_part_sort;
extern struct part_descr bltin_part_numbers1;
extern struct part_descr bltin_part_numbers;
extern struct part_descr bltin_part_expt;
extern struct part_descr bltin_part_gcdlcm;
extern struct part_descr bltin_part_promise;
extern struct part_descr bltin_part_mapping;
extern struct part_descr bltin_part_finding;
extern struct part_descr bltin_part_vectops;
extern struct part_descr bltin_part_seq;
extern struct part_descr bltin_part_heapi;

static struct part_descr *(tab[]) = {
    &bltin_part_car_cdr,
    &bltin_part_rewrite,
    &bltin_part_miscmac,
    &bltin_part_inlines,
    &bltin_part_gvec,
    &bltin_part_alloc,
    &bltin_part_iohooks,
    &bltin_part_rw_igfs2,
    &bltin_part_rw_igfs1,
    &bltin_part_rw_igfs,
    &bltin_part_fielders,
    &bltin_part_typesys,
    &bltin_part_class,
    &bltin_part_fastgfs,
    &bltin_part_bootclsb,
    &bltin_part_object,
    &bltin_part_gfs,
    &bltin_part_eq,
    &bltin_part_pairs2,
    &bltin_part_pairs1,
    &bltin_part_pairs,
    &bltin_part_vector,
    &bltin_part_strings,
    &bltin_part_immobs1,
    &bltin_part_immobs,
    &bltin_part_bvec,
    &bltin_part_apply,
    &bltin_part_arith,
    &bltin_part_excepts,
    &bltin_part_quasiq,
    &bltin_part_sort,
    &bltin_part_numbers1,
    &bltin_part_numbers,
    &bltin_part_expt,
    &bltin_part_gcdlcm,
    &bltin_part_promise,
    &bltin_part_mapping,
    &bltin_part_finding,
    &bltin_part_vectops,
    &bltin_part_seq,
    &bltin_part_heapi,
    NULL };
struct module_descr module_bltin = { "bltin", tab,
	NUM_ROOTS, /* num_roots */
	bltin_root_vector,
	roots};

