/*
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
*/
/**********************************************
THIS FILE WAS AUTOMATICALLY GENERATED, AND MAY
BE AUTOMATICALLY RE-GENERATED WHEN THE COMPILER
CHANGES.  DO NOT MODIFY THIS FILE BY HAND!
**********************************************/

#define _SUBPROJ_BLTIN
#define _SCM_STRINGS
#define _C_STRINGS
#include "bltin_p.h"
extern struct part_descr bltin_part_strings;

/****** raw glue `make-string' ******/

#define num REG0
#define ch REG1

static char strings_make_string_0_name[] = "make-string";
#define FUNCTION strings_make_string_0_name

PROLOGUE(strings_make_string_0)

BEGIN_FWD(strings_make_string_0)
  FWD_MONOTONE(make_string_0_00)
END_FWD(strings_make_string_0)

MONOTONE(make_string_0_00)
{
char c;
UINT_32 n = fx2int(num);

    if (arg_count_reg == 1)
	c = ' ';
    else
	c = GET_IMMEDIATE_VALUE(ch);

    REG0 = bvec_alloc( fx2int(num)+1, string_class );
    memset( PTR_TO_DATAPTR(REG0), c, n );
    RETURN(1);
}

EPILOGUE(strings_make_string_0)

BEGIN_BACK(strings_make_string_0)
  BACK_MONOTONE(make_string_0_00)
END_BACK(strings_make_string_0)

static struct function_descr strings_make_string_0_descr = {
	JUMP_TABLE( strings_make_string_0 ),
	strings_make_string_0_name,
	&bltin_part_strings };
#undef FUNCTION

#undef num
#undef ch

/****** raw glue `string-fill!' ******/

#define str REG0
#define fill REG1

static char strings_string_fill_1_name[] = "string-fill!";
#define FUNCTION strings_string_fill_1_name

PROLOGUE(strings_string_fill_1)

BEGIN_FWD(strings_string_fill_1)
  FWD_MONOTONE(string_fill_1_00)
END_FWD(strings_string_fill_1)

MONOTONE(string_fill_1_00)
{
UINT_32 i;
char src, *dst;

    src = GET_IMMEDIATE_VALUE(fill);
    dst = (char *)PTR_TO_DATAPTR(str);
    for (i=string_length(str); i>0; i--)
	*dst++ = src;
    RETURN(1);
}

EPILOGUE(strings_string_fill_1)

BEGIN_BACK(strings_string_fill_1)
  BACK_MONOTONE(string_fill_1_00)
END_BACK(strings_string_fill_1)

static struct function_descr strings_string_fill_1_descr = {
	JUMP_TABLE( strings_string_fill_1 ),
	strings_string_fill_1_name,
	&bltin_part_strings };
#undef FUNCTION

#undef str
#undef fill

/****** raw glue `string-copy' ******/

#define str REG0

static char strings_string_copy_2_name[] = "string-copy";
#define FUNCTION strings_string_copy_2_name

PROLOGUE(strings_string_copy_2)

BEGIN_FWD(strings_string_copy_2)
  FWD_MONOTONE(string_copy_2_00)
END_FWD(strings_string_copy_2)

MONOTONE(string_copy_2_00)
{ 
UINT_32 len = SIZEOF_PTR(str);
obj new_str;

    new_str = bvec_alloc( len, string_class );
    memcpy( PTR_TO_DATAPTR(new_str), PTR_TO_DATAPTR(str), len );
    REG0 = new_str;
    RETURN(1);
}

EPILOGUE(strings_string_copy_2)

BEGIN_BACK(strings_string_copy_2)
  BACK_MONOTONE(string_copy_2_00)
END_BACK(strings_string_copy_2)

static struct function_descr strings_string_copy_2_descr = {
	JUMP_TABLE( strings_string_copy_2 ),
	strings_string_copy_2_name,
	&bltin_part_strings };
#undef FUNCTION

#undef str

/****** raw glue `substring' ******/

#define str REG0
#define start REG1
#define end REG2

static char strings_substring_3_name[] = "substring";
#define FUNCTION strings_substring_3_name

PROLOGUE(strings_substring_3)

BEGIN_FWD(strings_substring_3)
  FWD_MONOTONE(substring_3_00)
END_FWD(strings_substring_3)

MONOTONE(substring_3_00)
{
INT_32 i, j;
UINT_32 len, new_len;
obj new_str;

    len = SIZEOF_PTR(str) - 1;
    i = fx2int(start);
    if (arg_count_reg == 2)
        j = len;
    else
	j = fx2int(end);
    
    if (i < 0 || i > len)
	scheme_error( "start ~d out of range 0..~d", 
			2, start, int2fx(len) );
    if (j < i || j > len)
	scheme_error( "end ~d out of range ~d..~d\n", 
			3, end, start, int2fx(len) );
    
    new_len = j - i;
    new_str = bvec_alloc( new_len + 1, string_class );
    
    /* Note that we don't have to copy or put in a terminal NUL,
       because bvec_alloc guarantees that the whole last
       word is ZERO, so if you alloc n+1 BYTES, then the last
       BYTE will surely be zero (but the next-to-the-last byte
       might not be, because it may fall on the preceding word).
       This is even true if n=0. */
       
    memcpy( PTR_TO_DATAPTR(new_str), 
    	    string_text(str)+i,
	    new_len );
    REG0 = new_str;
    RETURN(1);
}

EPILOGUE(strings_substring_3)

BEGIN_BACK(strings_substring_3)
  BACK_MONOTONE(substring_3_00)
END_BACK(strings_substring_3)

static struct function_descr strings_substring_3_descr = {
	JUMP_TABLE( strings_substring_3 ),
	strings_substring_3_name,
	&bltin_part_strings };
#undef FUNCTION

#undef str
#undef start
#undef end

/****** raw glue `string-search' ******/

#define str REG0
#define search_crit REG1

static char strings_string_search_4_name[] = "string-search";
#define FUNCTION strings_string_search_4_name

PROLOGUE(strings_string_search_4)

BEGIN_FWD(strings_string_search_4)
  FWD_MONOTONE(string_search_4_00)
END_FWD(strings_string_search_4)

MONOTONE(string_search_4_00)
{
char *s0, *s;

    s0 = (char *)string_text(str);
    if (OBJ_ISA_ASCII_CHAR(search_crit))
	s = strchr( s0, (char)GET_IMMEDIATE_VALUE(search_crit) );
    else
	s = strstr( s0, string_text(search_crit) );
    if (s)
	REG0 = int2fx( s - s0 );
    else
	REG0 = FALSE_OBJ;
    RETURN(1);
}

EPILOGUE(strings_string_search_4)

BEGIN_BACK(strings_string_search_4)
  BACK_MONOTONE(string_search_4_00)
END_BACK(strings_string_search_4)

static struct function_descr strings_string_search_4_descr = {
	JUMP_TABLE( strings_string_search_4 ),
	strings_string_search_4_name,
	&bltin_part_strings };
#undef FUNCTION

#undef str
#undef search_crit

/****** raw glue `string' ******/


static char strings_string_5_name[] = "string";
#define FUNCTION strings_string_5_name

PROLOGUE(strings_string_5)

BEGIN_FWD(strings_string_5)
  FWD_MONOTONE(string_5_00)
END_FWD(strings_string_5)

MONOTONE(string_5_00)
{
char *p;
int i;
obj str, ch;

    str = bvec_alloc( arg_count_reg+1, string_class );
    p = (char *)PTR_TO_DATAPTR(str);
    for (i=0; i<arg_count_reg; i++)
    {
	ch = reg_ref(i);
	*p++ = GET_IMMEDIATE_VALUE(ch);
    }
    REG0 = str;
    RETURN(1);
}

EPILOGUE(strings_string_5)

BEGIN_BACK(strings_string_5)
  BACK_MONOTONE(string_5_00)
END_BACK(strings_string_5)

static struct function_descr strings_string_5_descr = {
	JUMP_TABLE( strings_string_5 ),
	strings_string_5_name,
	&bltin_part_strings };
#undef FUNCTION


/****** raw glue `list->string' ******/


static char strings_list_string_6_name[] = "list->string";
#define FUNCTION strings_list_string_6_name

PROLOGUE(strings_list_string_6)

BEGIN_FWD(strings_list_string_6)
  FWD_MONOTONE(list_string_6_00)
END_FWD(strings_list_string_6)

MONOTONE(list_string_6_00)
{
obj i, new_str;
UINT_32 n;
char *p;

    n = 0;
    for (i=REG0; PAIR_P(i); i=pair_cdr(i))
    {
	if (!OBJ_ISA_ASCII_CHAR(pair_car(i)))
	    scheme_error( "not char: ~a", 1, pair_car(i) );
	n++;
    }
    new_str = bvec_alloc( n+1, string_class );
    p = (char *)PTR_TO_DATAPTR(new_str);
    for (i=REG0; PAIR_P(i); i=pair_cdr(i))
    {
	*p++ = GET_IMMEDIATE_VALUE(pair_car(i));
    }
    REG0 = new_str;
    RETURN(1);
}

EPILOGUE(strings_list_string_6)

BEGIN_BACK(strings_list_string_6)
  BACK_MONOTONE(list_string_6_00)
END_BACK(strings_list_string_6)

static struct function_descr strings_list_string_6_descr = {
	JUMP_TABLE( strings_list_string_6 ),
	strings_list_string_6_name,
	&bltin_part_strings };
#undef FUNCTION


/****** raw glue `string->list' ******/

#define string REG0

static char strings_string_list_7_name[] = "string->list";
#define FUNCTION strings_string_list_7_name

PROLOGUE(strings_string_list_7)

BEGIN_FWD(strings_string_list_7)
  FWD_MONOTONE(string_list_7_00)
END_FWD(strings_string_list_7)

MONOTONE(string_list_7_00)
{
obj result;
const char *str;
unsigned i;

    result = NIL_OBJ;
    i = string_length(string);
    str = string_text(string) + i;
    while (i > 0)
    {
        result = cons( MAKE_ASCII_CHAR(*--str), result );
	i--;
    }
    REG0 = result;
    RETURN(1);
}

EPILOGUE(strings_string_list_7)

BEGIN_BACK(strings_string_list_7)
  BACK_MONOTONE(string_list_7_00)
END_BACK(strings_string_list_7)

static struct function_descr strings_string_list_7_descr = {
	JUMP_TABLE( strings_string_list_7 ),
	strings_string_list_7_name,
	&bltin_part_strings };
#undef FUNCTION

#undef string

/****** function `string=?' ******/
static char strings_string_8_name[] = "string=?";
#define FUNCTION strings_string_8_name

PROLOGUE(strings_string_8)

BEGIN_FWD(strings_string_8)
  FWD_MONOTONE(strings_string_8_0)
  FWD_MONOTONE(strings_string_8_1)
  FWD_MONOTONE(strings_string_8_2)
END_FWD(strings_string_8)

MONOTONE(strings_string_8_0)
{
    COUNT_ARGS(2);
    REG1 = REG1;
    REG0 = REG0;
    if (RB_NOT(STRING_P(REG0 /* str1 */)))
    {
	REG2 = REG0 /* str1 */;
	failed_type_check(LITERAL(0) /* (string=? type-check) */,LITERAL(1) /* str1 */,REG2,cons(string_class,NIL_OBJ));
	JUMP(2,strings_string_8_1);
    }
    else
    {
	JUMP(2,strings_string_8_1);
    }
}

MONOTONE(strings_string_8_1)
{
    if (RB_NOT(STRING_P(REG1 /* str2 */)))
    {
	REG2 = REG1 /* str2 */;
	failed_type_check(LITERAL(0) /* (string=? type-check) */,LITERAL(2) /* str2 */,REG2,cons(string_class,NIL_OBJ));
	JUMP(2,strings_string_8_2);
    }
    else
    {
	JUMP(2,strings_string_8_2);
    }
}

MONOTONE(strings_string_8_2)
{
    REG0 = rb_to_bo(string_eq(REG0 /* str1 */,REG1 /* str2 */));
    RETURN(1);
}

EPILOGUE(strings_string_8)

BEGIN_BACK(strings_string_8)
  BACK_MONOTONE(strings_string_8_0)
  BACK_MONOTONE(strings_string_8_1)
  BACK_MONOTONE(strings_string_8_2)
END_BACK(strings_string_8)

static struct function_descr strings_string_8_descr = {
	JUMP_TABLE( strings_string_8 ),
	strings_string_8_name,
	&bltin_part_strings };
#undef FUNCTION

/****** function `string-ci=?' ******/
static char strings_string_ci_9_name[] = "string-ci=?";
#define FUNCTION strings_string_ci_9_name

PROLOGUE(strings_string_ci_9)

BEGIN_FWD(strings_string_ci_9)
  FWD_MONOTONE(strings_string_ci_9_0)
  FWD_MONOTONE(strings_string_ci_9_1)
  FWD_MONOTONE(strings_string_ci_9_2)
END_FWD(strings_string_ci_9)

MONOTONE(strings_string_ci_9_0)
{
    COUNT_ARGS(2);
    REG1 = REG1;
    REG0 = REG0;
    if (RB_NOT(STRING_P(REG0 /* str1 */)))
    {
	REG2 = REG0 /* str1 */;
	failed_type_check(LITERAL(0) /* (string-ci=? type-check) */,LITERAL(1) /* str1 */,REG2,cons(string_class,NIL_OBJ));
	JUMP(2,strings_string_ci_9_1);
    }
    else
    {
	JUMP(2,strings_string_ci_9_1);
    }
}

MONOTONE(strings_string_ci_9_1)
{
    if (RB_NOT(STRING_P(REG1 /* str2 */)))
    {
	REG2 = REG1 /* str2 */;
	failed_type_check(LITERAL(0) /* (string-ci=? type-check) */,LITERAL(2) /* str2 */,REG2,cons(string_class,NIL_OBJ));
	JUMP(2,strings_string_ci_9_2);
    }
    else
    {
	JUMP(2,strings_string_ci_9_2);
    }
}

MONOTONE(strings_string_ci_9_2)
{
    REG0 = rb_to_bo(string_ci_eq(REG0 /* str1 */,REG1 /* str2 */));
    RETURN(1);
}

EPILOGUE(strings_string_ci_9)

BEGIN_BACK(strings_string_ci_9)
  BACK_MONOTONE(strings_string_ci_9_0)
  BACK_MONOTONE(strings_string_ci_9_1)
  BACK_MONOTONE(strings_string_ci_9_2)
END_BACK(strings_string_ci_9)

static struct function_descr strings_string_ci_9_descr = {
	JUMP_TABLE( strings_string_ci_9 ),
	strings_string_ci_9_name,
	&bltin_part_strings };
#undef FUNCTION

/****** function `string<?' ******/
static char strings_string_10_name[] = "string<?";
#define FUNCTION strings_string_10_name

PROLOGUE(strings_string_10)

BEGIN_FWD(strings_string_10)
  FWD_MONOTONE(strings_string_10_0)
  FWD_MONOTONE(strings_string_10_1)
  FWD_MONOTONE(strings_string_10_2)
END_FWD(strings_string_10)

MONOTONE(strings_string_10_0)
{
    COUNT_ARGS(2);
    REG1 = REG1;
    REG0 = REG0;
    if (RB_NOT(STRING_P(REG0 /* s1 */)))
    {
	REG2 = REG0 /* s1 */;
	failed_type_check(LITERAL(0) /* (string<? string-cmp type-check) */,LITERAL(1) /* s1 */,REG2,cons(string_class,NIL_OBJ));
	JUMP(2,strings_string_10_1);
    }
    else
    {
	JUMP(2,strings_string_10_1);
    }
}

MONOTONE(strings_string_10_1)
{
    if (RB_NOT(STRING_P(REG1 /* s2 */)))
    {
	REG2 = REG1 /* s2 */;
	failed_type_check(LITERAL(0) /* (string<? string-cmp type-check) */,LITERAL(2) /* s2 */,REG2,cons(string_class,NIL_OBJ));
	JUMP(2,strings_string_10_2);
    }
    else
    {
	JUMP(2,strings_string_10_2);
    }
}

MONOTONE(strings_string_10_2)
{
    REG0 = rb_to_bo(FX_LT(int2fx(string_cmp(REG0 /* s1 */,REG1 /* s2 */)),int2fx(0)));
    RETURN(1);
}

EPILOGUE(strings_string_10)

BEGIN_BACK(strings_string_10)
  BACK_MONOTONE(strings_string_10_0)
  BACK_MONOTONE(strings_string_10_1)
  BACK_MONOTONE(strings_string_10_2)
END_BACK(strings_string_10)

static struct function_descr strings_string_10_descr = {
	JUMP_TABLE( strings_string_10 ),
	strings_string_10_name,
	&bltin_part_strings };
#undef FUNCTION

/****** function `string>?' ******/
static char strings_string_11_name[] = "string>?";
#define FUNCTION strings_string_11_name

PROLOGUE(strings_string_11)

BEGIN_FWD(strings_string_11)
  FWD_MONOTONE(strings_string_11_0)
  FWD_MONOTONE(strings_string_11_1)
  FWD_MONOTONE(strings_string_11_2)
END_FWD(strings_string_11)

MONOTONE(strings_string_11_0)
{
    COUNT_ARGS(2);
    REG1 = REG1;
    REG0 = REG0;
    if (RB_NOT(STRING_P(REG0 /* s1 */)))
    {
	REG2 = REG0 /* s1 */;
	failed_type_check(LITERAL(0) /* (string>? string-cmp type-check) */,LITERAL(1) /* s1 */,REG2,cons(string_class,NIL_OBJ));
	JUMP(2,strings_string_11_1);
    }
    else
    {
	JUMP(2,strings_string_11_1);
    }
}

MONOTONE(strings_string_11_1)
{
    if (RB_NOT(STRING_P(REG1 /* s2 */)))
    {
	REG2 = REG1 /* s2 */;
	failed_type_check(LITERAL(0) /* (string>? string-cmp type-check) */,LITERAL(2) /* s2 */,REG2,cons(string_class,NIL_OBJ));
	JUMP(2,strings_string_11_2);
    }
    else
    {
	JUMP(2,strings_string_11_2);
    }
}

MONOTONE(strings_string_11_2)
{
    REG0 = rb_to_bo(FX_GT(int2fx(string_cmp(REG0 /* s1 */,REG1 /* s2 */)),int2fx(0)));
    RETURN(1);
}

EPILOGUE(strings_string_11)

BEGIN_BACK(strings_string_11)
  BACK_MONOTONE(strings_string_11_0)
  BACK_MONOTONE(strings_string_11_1)
  BACK_MONOTONE(strings_string_11_2)
END_BACK(strings_string_11)

static struct function_descr strings_string_11_descr = {
	JUMP_TABLE( strings_string_11 ),
	strings_string_11_name,
	&bltin_part_strings };
#undef FUNCTION

/****** function `string<=?' ******/
static char strings_string_12_name[] = "string<=?";
#define FUNCTION strings_string_12_name

PROLOGUE(strings_string_12)

BEGIN_FWD(strings_string_12)
  FWD_MONOTONE(strings_string_12_0)
  FWD_MONOTONE(strings_string_12_1)
  FWD_MONOTONE(strings_string_12_2)
END_FWD(strings_string_12)

MONOTONE(strings_string_12_0)
{
    COUNT_ARGS(2);
    REG1 = REG1;
    REG0 = REG0;
    if (RB_NOT(STRING_P(REG0 /* s1 */)))
    {
	REG2 = REG0 /* s1 */;
	failed_type_check(LITERAL(0) /* (string<=? string-cmp type-check) */,LITERAL(1) /* s1 */,REG2,cons(string_class,NIL_OBJ));
	JUMP(2,strings_string_12_1);
    }
    else
    {
	JUMP(2,strings_string_12_1);
    }
}

MONOTONE(strings_string_12_1)
{
    if (RB_NOT(STRING_P(REG1 /* s2 */)))
    {
	REG2 = REG1 /* s2 */;
	failed_type_check(LITERAL(0) /* (string<=? string-cmp type-check) */,LITERAL(2) /* s2 */,REG2,cons(string_class,NIL_OBJ));
	JUMP(2,strings_string_12_2);
    }
    else
    {
	JUMP(2,strings_string_12_2);
    }
}

MONOTONE(strings_string_12_2)
{
    REG0 = rb_to_bo(FX_LE(int2fx(string_cmp(REG0 /* s1 */,REG1 /* s2 */)),int2fx(0)));
    RETURN(1);
}

EPILOGUE(strings_string_12)

BEGIN_BACK(strings_string_12)
  BACK_MONOTONE(strings_string_12_0)
  BACK_MONOTONE(strings_string_12_1)
  BACK_MONOTONE(strings_string_12_2)
END_BACK(strings_string_12)

static struct function_descr strings_string_12_descr = {
	JUMP_TABLE( strings_string_12 ),
	strings_string_12_name,
	&bltin_part_strings };
#undef FUNCTION

/****** function `string>=?' ******/
static char strings_string_13_name[] = "string>=?";
#define FUNCTION strings_string_13_name

PROLOGUE(strings_string_13)

BEGIN_FWD(strings_string_13)
  FWD_MONOTONE(strings_string_13_0)
  FWD_MONOTONE(strings_string_13_1)
  FWD_MONOTONE(strings_string_13_2)
END_FWD(strings_string_13)

MONOTONE(strings_string_13_0)
{
    COUNT_ARGS(2);
    REG1 = REG1;
    REG0 = REG0;
    if (RB_NOT(STRING_P(REG0 /* s1 */)))
    {
	REG2 = REG0 /* s1 */;
	failed_type_check(LITERAL(0) /* (string>=? string-cmp type-check) */,LITERAL(1) /* s1 */,REG2,cons(string_class,NIL_OBJ));
	JUMP(2,strings_string_13_1);
    }
    else
    {
	JUMP(2,strings_string_13_1);
    }
}

MONOTONE(strings_string_13_1)
{
    if (RB_NOT(STRING_P(REG1 /* s2 */)))
    {
	REG2 = REG1 /* s2 */;
	failed_type_check(LITERAL(0) /* (string>=? string-cmp type-check) */,LITERAL(2) /* s2 */,REG2,cons(string_class,NIL_OBJ));
	JUMP(2,strings_string_13_2);
    }
    else
    {
	JUMP(2,strings_string_13_2);
    }
}

MONOTONE(strings_string_13_2)
{
    REG0 = rb_to_bo(FX_GE(int2fx(string_cmp(REG0 /* s1 */,REG1 /* s2 */)),int2fx(0)));
    RETURN(1);
}

EPILOGUE(strings_string_13)

BEGIN_BACK(strings_string_13)
  BACK_MONOTONE(strings_string_13_0)
  BACK_MONOTONE(strings_string_13_1)
  BACK_MONOTONE(strings_string_13_2)
END_BACK(strings_string_13)

static struct function_descr strings_string_13_descr = {
	JUMP_TABLE( strings_string_13 ),
	strings_string_13_name,
	&bltin_part_strings };
#undef FUNCTION

/****** function `string-ci<?' ******/
static char strings_string_ci_14_name[] = "string-ci<?";
#define FUNCTION strings_string_ci_14_name

PROLOGUE(strings_string_ci_14)

BEGIN_FWD(strings_string_ci_14)
  FWD_MONOTONE(strings_string_ci_14_0)
  FWD_MONOTONE(strings_string_ci_14_1)
  FWD_MONOTONE(strings_string_ci_14_2)
END_FWD(strings_string_ci_14)

MONOTONE(strings_string_ci_14_0)
{
    COUNT_ARGS(2);
    REG1 = REG1;
    REG0 = REG0;
    if (RB_NOT(STRING_P(REG0 /* s1 */)))
    {
	REG2 = REG0 /* s1 */;
	failed_type_check(LITERAL(0) /* (string-ci<? string-ci-cmp type-check) */,LITERAL(1) /* s1 */,REG2,cons(string_class,NIL_OBJ));
	JUMP(2,strings_string_ci_14_1);
    }
    else
    {
	JUMP(2,strings_string_ci_14_1);
    }
}

MONOTONE(strings_string_ci_14_1)
{
    if (RB_NOT(STRING_P(REG1 /* s2 */)))
    {
	REG2 = REG1 /* s2 */;
	failed_type_check(LITERAL(0) /* (string-ci<? string-ci-cmp type-check) */,LITERAL(2) /* s2 */,REG2,cons(string_class,NIL_OBJ));
	JUMP(2,strings_string_ci_14_2);
    }
    else
    {
	JUMP(2,strings_string_ci_14_2);
    }
}

MONOTONE(strings_string_ci_14_2)
{
    REG0 = rb_to_bo(FX_LT(int2fx(string_ci_cmp(REG0 /* s1 */,REG1 /* s2 */)),int2fx(0)));
    RETURN(1);
}

EPILOGUE(strings_string_ci_14)

BEGIN_BACK(strings_string_ci_14)
  BACK_MONOTONE(strings_string_ci_14_0)
  BACK_MONOTONE(strings_string_ci_14_1)
  BACK_MONOTONE(strings_string_ci_14_2)
END_BACK(strings_string_ci_14)

static struct function_descr strings_string_ci_14_descr = {
	JUMP_TABLE( strings_string_ci_14 ),
	strings_string_ci_14_name,
	&bltin_part_strings };
#undef FUNCTION

/****** function `string-ci>?' ******/
static char strings_string_ci_15_name[] = "string-ci>?";
#define FUNCTION strings_string_ci_15_name

PROLOGUE(strings_string_ci_15)

BEGIN_FWD(strings_string_ci_15)
  FWD_MONOTONE(strings_string_ci_15_0)
  FWD_MONOTONE(strings_string_ci_15_1)
  FWD_MONOTONE(strings_string_ci_15_2)
END_FWD(strings_string_ci_15)

MONOTONE(strings_string_ci_15_0)
{
    COUNT_ARGS(2);
    REG1 = REG1;
    REG0 = REG0;
    if (RB_NOT(STRING_P(REG0 /* s1 */)))
    {
	REG2 = REG0 /* s1 */;
	failed_type_check(LITERAL(0) /* (string-ci>? string-ci-cmp type-check) */,LITERAL(1) /* s1 */,REG2,cons(string_class,NIL_OBJ));
	JUMP(2,strings_string_ci_15_1);
    }
    else
    {
	JUMP(2,strings_string_ci_15_1);
    }
}

MONOTONE(strings_string_ci_15_1)
{
    if (RB_NOT(STRING_P(REG1 /* s2 */)))
    {
	REG2 = REG1 /* s2 */;
	failed_type_check(LITERAL(0) /* (string-ci>? string-ci-cmp type-check) */,LITERAL(2) /* s2 */,REG2,cons(string_class,NIL_OBJ));
	JUMP(2,strings_string_ci_15_2);
    }
    else
    {
	JUMP(2,strings_string_ci_15_2);
    }
}

MONOTONE(strings_string_ci_15_2)
{
    REG0 = rb_to_bo(FX_GT(int2fx(string_ci_cmp(REG0 /* s1 */,REG1 /* s2 */)),int2fx(0)));
    RETURN(1);
}

EPILOGUE(strings_string_ci_15)

BEGIN_BACK(strings_string_ci_15)
  BACK_MONOTONE(strings_string_ci_15_0)
  BACK_MONOTONE(strings_string_ci_15_1)
  BACK_MONOTONE(strings_string_ci_15_2)
END_BACK(strings_string_ci_15)

static struct function_descr strings_string_ci_15_descr = {
	JUMP_TABLE( strings_string_ci_15 ),
	strings_string_ci_15_name,
	&bltin_part_strings };
#undef FUNCTION

/****** function `string-ci<=?' ******/
static char strings_string_ci_16_name[] = "string-ci<=?";
#define FUNCTION strings_string_ci_16_name

PROLOGUE(strings_string_ci_16)

BEGIN_FWD(strings_string_ci_16)
  FWD_MONOTONE(strings_string_ci_16_0)
  FWD_MONOTONE(strings_string_ci_16_1)
  FWD_MONOTONE(strings_string_ci_16_2)
END_FWD(strings_string_ci_16)

MONOTONE(strings_string_ci_16_0)
{
    COUNT_ARGS(2);
    REG1 = REG1;
    REG0 = REG0;
    if (RB_NOT(STRING_P(REG0 /* s1 */)))
    {
	REG2 = REG0 /* s1 */;
	failed_type_check(LITERAL(0) /* (string-ci<=? string-ci-cmp type-check) */,LITERAL(1) /* s1 */,REG2,cons(string_class,NIL_OBJ));
	JUMP(2,strings_string_ci_16_1);
    }
    else
    {
	JUMP(2,strings_string_ci_16_1);
    }
}

MONOTONE(strings_string_ci_16_1)
{
    if (RB_NOT(STRING_P(REG1 /* s2 */)))
    {
	REG2 = REG1 /* s2 */;
	failed_type_check(LITERAL(0) /* (string-ci<=? string-ci-cmp type-check) */,LITERAL(2) /* s2 */,REG2,cons(string_class,NIL_OBJ));
	JUMP(2,strings_string_ci_16_2);
    }
    else
    {
	JUMP(2,strings_string_ci_16_2);
    }
}

MONOTONE(strings_string_ci_16_2)
{
    REG0 = rb_to_bo(FX_LE(int2fx(string_ci_cmp(REG0 /* s1 */,REG1 /* s2 */)),int2fx(0)));
    RETURN(1);
}

EPILOGUE(strings_string_ci_16)

BEGIN_BACK(strings_string_ci_16)
  BACK_MONOTONE(strings_string_ci_16_0)
  BACK_MONOTONE(strings_string_ci_16_1)
  BACK_MONOTONE(strings_string_ci_16_2)
END_BACK(strings_string_ci_16)

static struct function_descr strings_string_ci_16_descr = {
	JUMP_TABLE( strings_string_ci_16 ),
	strings_string_ci_16_name,
	&bltin_part_strings };
#undef FUNCTION

/****** function `string-ci>=?' ******/
static char strings_string_ci_17_name[] = "string-ci>=?";
#define FUNCTION strings_string_ci_17_name

PROLOGUE(strings_string_ci_17)

BEGIN_FWD(strings_string_ci_17)
  FWD_MONOTONE(strings_string_ci_17_0)
  FWD_MONOTONE(strings_string_ci_17_1)
  FWD_MONOTONE(strings_string_ci_17_2)
END_FWD(strings_string_ci_17)

MONOTONE(strings_string_ci_17_0)
{
    COUNT_ARGS(2);
    REG1 = REG1;
    REG0 = REG0;
    if (RB_NOT(STRING_P(REG0 /* s1 */)))
    {
	REG2 = REG0 /* s1 */;
	failed_type_check(LITERAL(0) /* (string-ci>=? string-ci-cmp type-check) */,LITERAL(1) /* s1 */,REG2,cons(string_class,NIL_OBJ));
	JUMP(2,strings_string_ci_17_1);
    }
    else
    {
	JUMP(2,strings_string_ci_17_1);
    }
}

MONOTONE(strings_string_ci_17_1)
{
    if (RB_NOT(STRING_P(REG1 /* s2 */)))
    {
	REG2 = REG1 /* s2 */;
	failed_type_check(LITERAL(0) /* (string-ci>=? string-ci-cmp type-check) */,LITERAL(2) /* s2 */,REG2,cons(string_class,NIL_OBJ));
	JUMP(2,strings_string_ci_17_2);
    }
    else
    {
	JUMP(2,strings_string_ci_17_2);
    }
}

MONOTONE(strings_string_ci_17_2)
{
    REG0 = rb_to_bo(FX_GE(int2fx(string_ci_cmp(REG0 /* s1 */,REG1 /* s2 */)),int2fx(0)));
    RETURN(1);
}

EPILOGUE(strings_string_ci_17)

BEGIN_BACK(strings_string_ci_17)
  BACK_MONOTONE(strings_string_ci_17_0)
  BACK_MONOTONE(strings_string_ci_17_1)
  BACK_MONOTONE(strings_string_ci_17_2)
END_BACK(strings_string_ci_17)

static struct function_descr strings_string_ci_17_descr = {
	JUMP_TABLE( strings_string_ci_17 ),
	strings_string_ci_17_name,
	&bltin_part_strings };
#undef FUNCTION

/****** function `symbol->string' ******/
static char strings_symbol_string_18_name[] = "symbol->string";
#define FUNCTION strings_symbol_string_18_name

PROLOGUE(strings_symbol_string_18)

BEGIN_FWD(strings_symbol_string_18)
  FWD_MONOTONE(strings_symbol_string_18_0)
  FWD_MONOTONE(strings_symbol_string_18_1)
END_FWD(strings_symbol_string_18)

MONOTONE(strings_symbol_string_18_0)
{
    COUNT_ARGS(1);
    REG0 = REG0;
    if (RB_NOT(SYMBOL_P(REG0 /* sym */)))
    {
	REG1 = REG0 /* sym */;
	failed_type_check(LITERAL(0) /* (symbol->string type-check) */,LITERAL(1) /* sym */,REG1,cons(symbol_class,NIL_OBJ));
	JUMP(1,strings_symbol_string_18_1);
    }
    else
    {
	JUMP(1,strings_symbol_string_18_1);
    }
}

MONOTONE(strings_symbol_string_18_1)
{
    REG0 = gvec_read(REG0 /* sym */,SLOT(0));
    RETURN(1);
}

EPILOGUE(strings_symbol_string_18)

BEGIN_BACK(strings_symbol_string_18)
  BACK_MONOTONE(strings_symbol_string_18_0)
  BACK_MONOTONE(strings_symbol_string_18_1)
END_BACK(strings_symbol_string_18)

static struct function_descr strings_symbol_string_18_descr = {
	JUMP_TABLE( strings_symbol_string_18 ),
	strings_symbol_string_18_name,
	&bltin_part_strings };
#undef FUNCTION

/****** function `string->symbol' ******/
static char strings_string_symbol_19_name[] = "string->symbol";
#define FUNCTION strings_string_symbol_19_name

PROLOGUE(strings_string_symbol_19)

BEGIN_FWD(strings_string_symbol_19)
  FWD_MONOTONE(strings_string_symbol_19_0)
  FWD_MONOTONE(strings_string_symbol_19_1)
END_FWD(strings_string_symbol_19)

MONOTONE(strings_string_symbol_19_0)
{
    COUNT_ARGS(1);
    REG0 = REG0;
    if (RB_NOT(STRING_P(REG0 /* str */)))
    {
	REG1 = REG0 /* str */;
	failed_type_check(LITERAL(0) /* (string->symbol type-check) */,LITERAL(1) /* str */,REG1,cons(string_class,NIL_OBJ));
	JUMP(1,strings_string_symbol_19_1);
    }
    else
    {
	JUMP(1,strings_string_symbol_19_1);
    }
}

MONOTONE(strings_string_symbol_19_1)
{
    REG0 = intern(REG0 /* str */);
    RETURN(1);
}

EPILOGUE(strings_string_symbol_19)

BEGIN_BACK(strings_string_symbol_19)
  BACK_MONOTONE(strings_string_symbol_19_0)
  BACK_MONOTONE(strings_string_symbol_19_1)
END_BACK(strings_string_symbol_19)

static struct function_descr strings_string_symbol_19_descr = {
	JUMP_TABLE( strings_string_symbol_19 ),
	strings_string_symbol_19_name,
	&bltin_part_strings };
#undef FUNCTION

/****** function `$gensym' ******/
static char strings_gensym_20_name[] = "$gensym";
#define FUNCTION strings_gensym_20_name

PROLOGUE(strings_gensym_20)

BEGIN_FWD(strings_gensym_20)
  FWD_MONOTONE(strings_gensym_20_0)
  FWD_MONOTONE(strings_gensym_20_1)
  FWD_MONOTONE(strings_gensym_20_2)
  FWD_MONOTONE(strings_gensym_20_3)
END_FWD(strings_gensym_20)

MONOTONE(strings_gensym_20_0)
{
    COUNT_ARGS(0);
    SAVE_CONT0(strings_gensym_20_1);
    REG0 = TLREF(0) /* *temp-symbol-ctr* */;
    APPLY(1,TLREF(1) /* _add1 */);
}

MONOTONE(strings_gensym_20_1)
{
    REG0 = REG0;
    RESTORE_CONT0();
    TLSET(0 /* *temp-symbol-ctr* */,REG0);
    SAVE_CONT0(strings_gensym_20_3);
    REG0 = LITERAL(2) /* "G#" */;
    SAVE_CONT1(strings_gensym_20_2);
    REG0 = TLREF(0) /* *temp-symbol-ctr* */;
    APPLY(1,TLREF(3) /* number->string */);
}

MONOTONE(strings_gensym_20_2)
{
    REG1 = REG0;
    RESTORE_CONT1();
    REG1 = REG1;
    APPLY(2,TLREF(4) /* string-append */);
}

MONOTONE(strings_gensym_20_3)
{
    REG0 = REG0;
    RESTORE_CONT0();
    REG0 = REG0;
    APPLY(1,TLREF(5) /* string->symbol */);
}

EPILOGUE(strings_gensym_20)

BEGIN_BACK(strings_gensym_20)
  BACK_MONOTONE(strings_gensym_20_0)
  BACK_MONOTONE(strings_gensym_20_1)
  BACK_MONOTONE(strings_gensym_20_2)
  BACK_MONOTONE(strings_gensym_20_3)
END_BACK(strings_gensym_20)

static struct function_descr strings_gensym_20_descr = {
	JUMP_TABLE( strings_gensym_20 ),
	strings_gensym_20_name,
	&bltin_part_strings };
#undef FUNCTION

/****** raw glue `string-append' ******/


static char strings_string_append_21_name[] = "string-append";
#define FUNCTION strings_string_append_21_name

PROLOGUE(strings_string_append_21)

BEGIN_FWD(strings_string_append_21)
  FWD_MONOTONE(string_append_21_00)
END_FWD(strings_string_append_21)

MONOTONE(string_append_21_00)
{
unsigned i, len, n;
char *p;
obj new_str, str;

    len = 0;
    for (i=0; i<arg_count_reg; i++)
    {
	str = reg_ref(i);
	if (!STRING_P(str))
	    scheme_error( "string-append: Not a string ~a", 1, str );
	len += string_length(str);
    }
    new_str = bvec_alloc( len+1, string_class );
    p = (char *)PTR_TO_DATAPTR(new_str);
    for (i=0; i<arg_count_reg; i++)
    {
	str = reg_ref(i);
        n = string_length( str );
	memcpy( p, string_text(str), n );
	p += n;
    }
    REG0 = new_str;
    RETURN(1);
}

EPILOGUE(strings_string_append_21)

BEGIN_BACK(strings_string_append_21)
  BACK_MONOTONE(string_append_21_00)
END_BACK(strings_string_append_21)

static struct function_descr strings_string_append_21_descr = {
	JUMP_TABLE( strings_string_append_21 ),
	strings_string_append_21_name,
	&bltin_part_strings };
#undef FUNCTION


/****** function `_string-length' ******/
static char strings_string_length_22_name[] = "_string-length";
#define FUNCTION strings_string_length_22_name

PROLOGUE(strings_string_length_22)

BEGIN_FWD(strings_string_length_22)
  FWD_MONOTONE(strings_string_length_22_0)
  FWD_MONOTONE(strings_string_length_22_1)
END_FWD(strings_string_length_22)

MONOTONE(strings_string_length_22_0)
{
    COUNT_ARGS(1);
    REG0 = REG0;
    if (RB_NOT(STRING_P(REG0 /* str */)))
    {
	REG1 = REG0 /* str */;
	failed_type_check(LITERAL(0) /* (_string-length type-check) */,LITERAL(1) /* str */,REG1,cons(string_class,NIL_OBJ));
	JUMP(1,strings_string_length_22_1);
    }
    else
    {
	JUMP(1,strings_string_length_22_1);
    }
}

MONOTONE(strings_string_length_22_1)
{
    REG0 = int2fx(string_length(REG0 /* str */));
    RETURN(1);
}

EPILOGUE(strings_string_length_22)

BEGIN_BACK(strings_string_length_22)
  BACK_MONOTONE(strings_string_length_22_0)
  BACK_MONOTONE(strings_string_length_22_1)
END_BACK(strings_string_length_22)

static struct function_descr strings_string_length_22_descr = {
	JUMP_TABLE( strings_string_length_22 ),
	strings_string_length_22_name,
	&bltin_part_strings };
#undef FUNCTION

/****** function `_string-ref' ******/
static char strings_string_ref_23_name[] = "_string-ref";
#define FUNCTION strings_string_ref_23_name

PROLOGUE(strings_string_ref_23)

BEGIN_FWD(strings_string_ref_23)
  FWD_MONOTONE(strings_string_ref_23_0)
  FWD_MONOTONE(strings_string_ref_23_1)
  FWD_MONOTONE(strings_string_ref_23_2)
END_FWD(strings_string_ref_23)

MONOTONE(strings_string_ref_23_0)
{
    COUNT_ARGS(2);
    REG1 = REG1;
    REG0 = REG0;
    if (RB_NOT(STRING_P(REG0 /* str */)))
    {
	REG2 = REG0 /* str */;
	failed_type_check(LITERAL(0) /* (_string-ref type-check) */,LITERAL(1) /* str */,REG2,cons(string_class,NIL_OBJ));
	JUMP(2,strings_string_ref_23_1);
    }
    else
    {
	JUMP(2,strings_string_ref_23_1);
    }
}

MONOTONE(strings_string_ref_23_1)
{
    if (RB_NOT(OBJ_ISA_FIXNUM(REG1 /* i */)))
    {
	REG2 = REG1 /* i */;
	failed_type_check(LITERAL(0) /* (_string-ref type-check) */,LITERAL(2) /* i */,REG2,cons(fixnum_class,NIL_OBJ));
	JUMP(2,strings_string_ref_23_2);
    }
    else
    {
	JUMP(2,strings_string_ref_23_2);
    }
}

MONOTONE(strings_string_ref_23_2)
{
    REG0 = string_ref(REG0 /* str */,fx2int(REG1 /* i */));
    RETURN(1);
}

EPILOGUE(strings_string_ref_23)

BEGIN_BACK(strings_string_ref_23)
  BACK_MONOTONE(strings_string_ref_23_0)
  BACK_MONOTONE(strings_string_ref_23_1)
  BACK_MONOTONE(strings_string_ref_23_2)
END_BACK(strings_string_ref_23)

static struct function_descr strings_string_ref_23_descr = {
	JUMP_TABLE( strings_string_ref_23 ),
	strings_string_ref_23_name,
	&bltin_part_strings };
#undef FUNCTION

/****** function `_string-set!' ******/
static char strings_string_set_24_name[] = "_string-set!";
#define FUNCTION strings_string_set_24_name

PROLOGUE(strings_string_set_24)

BEGIN_FWD(strings_string_set_24)
  FWD_MONOTONE(strings_string_set_24_0)
  FWD_MONOTONE(strings_string_set_24_1)
  FWD_MONOTONE(strings_string_set_24_2)
  FWD_MONOTONE(strings_string_set_24_3)
END_FWD(strings_string_set_24)

MONOTONE(strings_string_set_24_0)
{
    COUNT_ARGS(3);
    REG2 = REG2;
    REG1 = REG1;
    REG0 = REG0;
    if (RB_NOT(STRING_P(REG0 /* str */)))
    {
	REG3 = REG0 /* str */;
	failed_type_check(LITERAL(0) /* (_string-set! type-check) */,LITERAL(1) /* str */,REG3,cons(string_class,NIL_OBJ));
	JUMP(3,strings_string_set_24_1);
    }
    else
    {
	JUMP(3,strings_string_set_24_1);
    }
}

MONOTONE(strings_string_set_24_1)
{
    if (RB_NOT(OBJ_ISA_FIXNUM(REG1 /* i */)))
    {
	REG3 = REG1 /* i */;
	failed_type_check(LITERAL(0) /* (_string-set! type-check) */,LITERAL(2) /* i */,REG3,cons(fixnum_class,NIL_OBJ));
	JUMP(3,strings_string_set_24_2);
    }
    else
    {
	JUMP(3,strings_string_set_24_2);
    }
}

MONOTONE(strings_string_set_24_2)
{
    if (RB_NOT(OBJ_ISA_ASCII_CHAR(REG2 /* c */)))
    {
	REG3 = REG2 /* c */;
	failed_type_check(LITERAL(0) /* (_string-set! type-check) */,LITERAL(3) /* c */,REG3,cons(ascii_char_class,NIL_OBJ));
	JUMP(3,strings_string_set_24_3);
    }
    else
    {
	JUMP(3,strings_string_set_24_3);
    }
}

MONOTONE(strings_string_set_24_3)
{
    string_set(REG0 /* str */,fx2int(REG1 /* i */),REG2 /* c */);
    REG0 = REG2 /* c */;
    RETURN(1);
}

EPILOGUE(strings_string_set_24)

BEGIN_BACK(strings_string_set_24)
  BACK_MONOTONE(strings_string_set_24_0)
  BACK_MONOTONE(strings_string_set_24_1)
  BACK_MONOTONE(strings_string_set_24_2)
  BACK_MONOTONE(strings_string_set_24_3)
END_BACK(strings_string_set_24)

static struct function_descr strings_string_set_24_descr = {
	JUMP_TABLE( strings_string_set_24 ),
	strings_string_set_24_name,
	&bltin_part_strings };
#undef FUNCTION

/****** function `c-text?' ******/
static char strings_c_text_25_name[] = "c-text?";
#define FUNCTION strings_c_text_25_name

PROLOGUE(strings_c_text_25)

BEGIN_FWD(strings_c_text_25)
  FWD_MONOTONE(strings_c_text_25_0)
END_FWD(strings_c_text_25)

MONOTONE(strings_c_text_25_0)
{
    COUNT_ARGS(1);
    REG0 = REG0;
    if (OBJ_ISA_PTR(REG0 /* thing */))
    {
	REG1 = CLASSOF_PTR(REG0 /* thing */);
	REG0 = rb_to_bo(EQ(REG1,c_text_class));
	RETURN(1);
    }
    else
    {
	REG0 = FALSE_OBJ;
	RETURN(1);
    }
}

EPILOGUE(strings_c_text_25)

BEGIN_BACK(strings_c_text_25)
  BACK_MONOTONE(strings_c_text_25_0)
END_BACK(strings_c_text_25)

static struct function_descr strings_c_text_25_descr = {
	JUMP_TABLE( strings_c_text_25 ),
	strings_c_text_25_name,
	&bltin_part_strings };
#undef FUNCTION

/****** function `string->c-text' ******/
static char strings_string_c_text_26_name[] = "string->c-text";
#define FUNCTION strings_string_c_text_26_name

PROLOGUE(strings_string_c_text_26)

BEGIN_FWD(strings_string_c_text_26)
  FWD_MONOTONE(strings_string_c_text_26_0)
  FWD_MONOTONE(strings_string_c_text_26_1)
END_FWD(strings_string_c_text_26)

MONOTONE(strings_string_c_text_26_0)
{
    COUNT_ARGS(1);
    REG0 = REG0;
    if (RB_NOT(STRING_P(REG0 /* str */)))
    {
	REG1 = REG0 /* str */;
	failed_type_check(LITERAL(0) /* (string->c-text type-check) */,LITERAL(1) /* str */,REG1,cons(string_class,NIL_OBJ));
	JUMP(1,strings_string_c_text_26_1);
    }
    else
    {
	JUMP(1,strings_string_c_text_26_1);
    }
}

MONOTONE(strings_string_c_text_26_1)
{
    REG0 = make1(c_text_class,REG0 /* str */);
    RETURN(1);
}

EPILOGUE(strings_string_c_text_26)

BEGIN_BACK(strings_string_c_text_26)
  BACK_MONOTONE(strings_string_c_text_26_0)
  BACK_MONOTONE(strings_string_c_text_26_1)
END_BACK(strings_string_c_text_26)

static struct function_descr strings_string_c_text_26_descr = {
	JUMP_TABLE( strings_string_c_text_26 ),
	strings_string_c_text_26_name,
	&bltin_part_strings };
#undef FUNCTION

/****** function `c-text->string' ******/
static char strings_c_text_string_27_name[] = "c-text->string";
#define FUNCTION strings_c_text_string_27_name

PROLOGUE(strings_c_text_string_27)

BEGIN_FWD(strings_c_text_string_27)
  FWD_MONOTONE(strings_c_text_string_27_0)
  FWD_MONOTONE(strings_c_text_string_27_1)
  FWD_MONOTONE(strings_c_text_string_27_2)
END_FWD(strings_c_text_string_27)

MONOTONE(strings_c_text_string_27_0)
{
    COUNT_ARGS(1);
    BEGIN_BIND1()
	BIND_ARG(0,REG0);
    END_BIND
    SAVE_CONT0(strings_c_text_string_27_1);
    REG0 = LEXREF0(0) /* ctext */;
    APPLY(1,TLREF(0) /* c-text? */);
}

MONOTONE(strings_c_text_string_27_1)
{
    REG0 = REG0;
    RESTORE_CONT0();
    if (RB_NOT(truish(REG0)))
    {
	REG0 = LEXREF0(0) /* ctext */;
	failed_type_check(LITERAL(1) /* (c-text->string type-check) */,LITERAL(2) /* ctext */,REG0,cons(c_text_class,NIL_OBJ));
	JUMP(0,strings_c_text_string_27_2);
    }
    else
    {
	JUMP(0,strings_c_text_string_27_2);
    }
}

MONOTONE(strings_c_text_string_27_2)
{
    REG0 = gvec_read(LEXREF0(0) /* ctext */,SLOT(0));
    RETURN(1);
}

EPILOGUE(strings_c_text_string_27)

BEGIN_BACK(strings_c_text_string_27)
  BACK_MONOTONE(strings_c_text_string_27_0)
  BACK_MONOTONE(strings_c_text_string_27_1)
  BACK_MONOTONE(strings_c_text_string_27_2)
END_BACK(strings_c_text_string_27)

static struct function_descr strings_c_text_string_27_descr = {
	JUMP_TABLE( strings_c_text_string_27 ),
	strings_c_text_string_27_name,
	&bltin_part_strings };
#undef FUNCTION


/*** Part Link Table ***/

static struct function_descr *(part_strings_tab[]) = {
    &strings_make_string_0_descr,
    &strings_string_fill_1_descr,
    &strings_string_copy_2_descr,
    &strings_substring_3_descr,
    &strings_string_search_4_descr,
    &strings_string_5_descr,
    &strings_list_string_6_descr,
    &strings_string_list_7_descr,
    &strings_string_8_descr,
    &strings_string_ci_9_descr,
    &strings_string_10_descr,
    &strings_string_11_descr,
    &strings_string_12_descr,
    &strings_string_13_descr,
    &strings_string_ci_14_descr,
    &strings_string_ci_15_descr,
    &strings_string_ci_16_descr,
    &strings_string_ci_17_descr,
    &strings_symbol_string_18_descr,
    &strings_string_symbol_19_descr,
    &strings_gensym_20_descr,
    &strings_string_append_21_descr,
    &strings_string_length_22_descr,
    &strings_string_ref_23_descr,
    &strings_string_set_24_descr,
    &strings_c_text_25_descr,
    &strings_string_c_text_26_descr,
    &strings_c_text_string_27_descr,
    NULL };
struct part_descr bltin_part_strings = {
    163987261,
    &module_bltin,
    part_strings_tab,
    "strings",
    0 };
#undef _SUBPROJ_BLTIN
#undef _SCM_STRINGS
#undef _C_STRINGS
