#|
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
|#
(define-class <Object> ())
(define-class <Slot-Descriptor> (<Object>))

(define-class <number> (<Object>))
(define-class <complex> (<number>))
(define-class <real> (<complex>))
(define-class <float> (<real>))
(define-class <rational> (<float>))
(define-class <integer> (<rational>))
(define-class <ratio> (<rational>))

(define-class root: "fixnum_class" <FixNum> (<integer>) :immob)

(define-class root: "double_float_class" <double-float> (<float>) 
	:bvec
	image-mode: 6)	; has to be swizzled as a 64-bit quantity



(%gvec-write <Slot-Descriptor> 4
    (list (%slot (name #f <Symbol>) 0)
    	  (%slot (default-value #f) 1)
	  (%slot (slot-type <Object> <<Class>>) 2)
	  (%slot (position #f <FixNum>) 3)
	  (%slot (keyword #f <Symbol>) 4)))

(define-class <Method> (<Object>) :no-ivar-gfs
    (specializers '())
    (implementation #f <Closure>))

(define-class <Binding> (<Object>) :no-ivar-gfs
	name)

(define-class <Environment> (<Object>))
(define-class <List> (<Object>))

#|
(define-class root: "hashtable_class" <HashTable> (<Object>))
(define-class root: "hashbucket_class" <HashBucket> (<Object>))
|#
(define-class root: "tle_class" <TopLevelEnvt> (<Environment>) 
	:no-ivar-gfs 
	table)
(define-class root: "tlv_class" <TopLevelVar> (<Binding>)
	:no-ivar-gfs
	(value '#unbound)
	write-prot)
(define-class root: "template_class" <Template> (<Object>))

#|
(define-system "<HashTable>" <HashTable>)
(define-system "<HashBucket>" <HashBucket>)
|#
(define-system "<TopLevelVar>" <TopLevelVar>)
(define-system "<TopLevelEnvt>" <TopLevelEnvt>)
(define-system "<Template>" <Template>)
(define-system "<LongFloat>" <double-float>)


(%define-glue (%replace-gvec old_new)
{
UINT_32 i;
obj old_gvec, new_gvec;

    assert( PAIR_P(old_new) );
    old_gvec = pair_car( old_new );
    new_gvec = pair_cdr( old_new );
    
    assert( OBJ_ISA_PTR(old_gvec) );
    assert( OBJ_ISA_PTR(new_gvec) );
    assert( EQ( CLASSOF_PTR(old_gvec), CLASSOF_PTR(new_gvec) ) );
    
    i = SIZEOF_PTR(new_gvec);
    assert( i <= SIZEOF_PTR(old_gvec) );
    
    while (i > 0)
    {
        i -= 4;
	gvec_write( old_gvec, i, gvec_read( new_gvec, i ) );
    }
    REG0 = new_gvec;
    RETURN(1);
})

(define standard-replacement-classes
    (list   
	(cons <<Class>>
	    (make-class <<Class>> (<Object>)
		    (name #f <Symbol>)
		    (heap-type #f)
		    (image-mode 0 <FixNum>)
		    (superclasses '())
		    (slots '())
		    (write-method $write-trap)
		    (display-method $display-trap)
		    (initialize-method $initialize-trap)))
	(cons <Symbol> 
	      (make-class <Symbol> (<Object>) image-mode: 2
		    (string-form #f <String>)
		    (hash-value 0 <FixNum>)))
	(cons <BindingEnvt> 
	      (make-class <BindingEnvt> (<Object>) 
		    enclosing-envt))
	(cons <String> 
	      (make-class <String> (<Object>) :bvec image-mode: 1))
	(cons <Vector>
	      (make-class <Vector> (<Object>)))
	(cons <Pair>
	      (make-class <Pair> (<List>)
		    car
		    cdr))
	(cons <TopLevelEnvt>
	      (make-class <TopLevelEnvt> (<Environment>)
		    table))
	(cons <TopLevelVar>
	      (make-class <TopLevelVar> (<Binding>)
		    (value '#unbound)
		    write-prot))
	(cons <Template>
	      (make-class <Template> (<Object>) image-mode: 4
		    code-ptr
		    function-descr))
	(cons <double-float>
	    (make-class <double-float> (<float>) :bvec image-mode: 6))
	(cons <Closure>
	      (make-class <Closure> (<Object>)
		    binding-envt
		    template))))




(define (replace-standard-classes)
    (for-each
	%replace-gvec
	standard-replacement-classes))
#|
    (let loop ((i 0))
	(if (eq? i (vector-length $replacements))
	    #f
	    (let ((x (vector-ref $replacements i)))
		($replace-1! (car x) (cdr x))
		(loop (add1 i))))))
|#

(run-named replace-standard-classes)

(export <Object> <Slot-Descriptor> <Method> 
	<Binding> <Environment>
	<TopLevelEnvt> <TopLevelVar> <Template> <List>
	%replace-gvec
	make-class)

(export <number> 
        <complex> <real> <float> <rational> <integer> <ratio> 
	<fixnum> <double-float>)

