#|
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
|#
(%define-glue $writer-dispatch literals: ('*output-port* 
					    (& %console-output-port))
{
    if (arg_count_reg == 1)
    {
        REG1 = fluid_assq( LITERAL(0) );
        if (EQ(REG1,FALSE_OBJ))
            REG1 = TLREF(1);
        else
            REG1 = pair_cdr( REG1 );
    }
    else if (arg_count_reg == 2)
    {
    /*
        if (!OUTPUT_PORT_P(REG1))
	{
            scheme_error( "~a: 2nd arg is not an output port: ~s",
			  2,
			  LEXREF0(2),
			  REG1 );
	}
    */
    }
    else
    {
        scheme_error( "~a: expected 1 or 2 args, got ~d",
		      2,
		      LEXREF0(2),
		      int2fx(arg_count_reg) );
    }
    APPLY( 2, gvec_read( class_of(REG0), FXWORDS_TO_RIBYTES(LEXREF0(0)) ) );
})


(define ($fast-gf-did-trap args gfe)
    (let ((c (class-of (car args)))
    	  (m (method-proc ((mme-find-method (gfe->mme gfe)) gfe args))))
	(%gvec-write c (fast-gfe-position gfe) m)
	(fast-gfe-set-cached-classes! 
	    gfe 
	    (cons c (fast-gfe-cached-classes gfe)))
	(apply* args m)))

(%define-glue $fast-gf-trap literals: ((& $fast-gf-did-trap))
{
    COLLECT0();
    REG1 = envt_reg;
    APPLY( 2, TLREF(0) );
})


(define ($fast-gf-flush-cache! gfe)
    (for-each
	(lambda (cached-class)
	    (%gvec-write cached-class 
		         (fast-gfe-position gfe)
			 (fast-gfe-trap gfe))
	    #f)
	(fast-gfe-cached-classes gfe))
    (fast-gfe-set-cached-classes! gfe '())
    '())


(define ($fast-gf-find-method gfe args)
    ($std-class-find-method (fast-gfe-methods gfe) args))

(define ($fast-gf-add-method! gfe method)
    ($fast-gf-flush-cache! gfe)
    (fast-gfe-set-methods! 
	gfe
	($std-class-install-method! (fast-gfe-methods gfe) method))
    method)

(define ($fast-gf-remove-method! gfe method)
    ($fast-gf-flush-cache! gfe)
    (fast-gfe-set-methods! gfe (delq! method (fast-gfe-methods gfe)))
    method)

(define ($fast-gf-remove-all-methods! gfe)
    ($fast-gf-flush-cache! gfe)
    (fast-gfe-set-methods! gfe '())
    gfe)

(define $fast-gf-meta-methods
    (%make-gf-envt
	   '()
	   $fast-gf-find-method
	   $fast-gf-add-method!
	   $fast-gf-remove-method!
	   $fast-gf-remove-all-methods!))

(define $write-gfe
    (%make-gf-envt
	    $fast-gf-meta-methods
	    5			;; LEXREF0(0): position
	    '()			;; LEXREF0(1): methods
	    'write		;; LEXREF0(2): name
	    #f                  ;; LEXREF0(3): generic-fn
	    '()			;; LEXREF0(4): cached-classes
	    #f))		;; LEXREF0(5): trap

(define $display-gfe
    (%make-gf-envt
	    $fast-gf-meta-methods
	    6			;; LEXREF0(0): position
	    '()			;; LEXREF0(1): methods
	    'display		;; LEXREF0(2): name
	    #f                  ;; LEXREF0(3): generic-fn
	    '()			;; LEXREF0(4): cached-classes
	    #f))		;; LEXREF0(5): trap

	    
(define write (%make-closure $write-gfe $writer-dispatch))
(define $write-trap (%make-closure $write-gfe $fast-gf-trap))
(%gvec-write $write-gfe 6 $write-trap)
(%gvec-write $write-gfe 4 write)

(define display (%make-closure $display-gfe $writer-dispatch))
(define $display-trap (%make-closure $display-gfe $fast-gf-trap))
(%gvec-write $display-gfe 6 $display-trap)
(%gvec-write $display-gfe 4 display)

(define $initialize-gfe
    (%make-gf-envt
	    $fast-gf-meta-methods
	    7			;; LEXREF0(0): position
	    '()			;; LEXREF0(1): methods
	    'initialize		;; LEXREF0(2): name
	    #f                  ;; LEXREF0(3): generic-fn
	    '()			;; LEXREF0(4): cached-classes
	    #f))		;; LEXREF0(5): trap

(%define-glue $init-dispatch
{
    if (arg_count_reg != 1)
    {
	scheme_error( "initialize: expected only 1 argument, got ~d",
		      1,
		      int2fx(arg_count_reg) );
    }
    APPLY( 1, gvec_read( class_of(REG0), SLOT(7) ) );
})

(export $writer-dispatch $init-dispatch)

(define initialize (%make-closure $initialize-gfe $init-dispatch))
(define $initialize-trap (%make-closure $initialize-gfe $fast-gf-trap))
(%gvec-write $initialize-gfe 6 $initialize-trap)
(%gvec-write $initialize-gfe 4 initialize)

(define-macro (%initialize thing)
    (let ((i thing))
	((%gvec-read (class-of-ptr i) 7) i)))

(export %initialize write display initialize)

(export $write-trap		;; [5] write method impl
	$display-trap		;; [6] display method impl
	$initialize-trap)	;; [7] initialize method impl
