#|
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
|#
;; slot operations
;;

(%define-glue $unchecked-setter
{
    if (arg_count_reg != 2)
    {
      scheme_error( "~a: Expected exactly two args, got ~d\n",
		    2,
		    LEXREF0(1),
		    int2fx(arg_count_reg) );
    }
    gvec_write( REG0,
		FXWORDS_TO_RIBYTES( LEXREF0(0) ),
		REG1 );
    REG0 = REG1;
    RETURN(1);
})

(%define-glue $checked-setter
{
    if (arg_count_reg != 2)
    {
      scheme_error( "~a: Expected exactly two args, got ~d\n",
		    2,
		    LEXREF0(2),
		    int2fx(arg_count_reg) );
    }
    if (!subclass_p( class_of(REG1), LEXREF0(1) ))
    {
      scheme_error( "~a: Invalid set value ~s expected a ~a",
		    3,
		    LEXREF0(2),
		    REG1,
		    LEXREF0(1) );
    }
    gvec_write( REG0,
		FXWORDS_TO_RIBYTES( LEXREF0(0) ),
		REG1 );
    REG0 = REG1;
    RETURN(1);
})    

(define-macro (%make-unchecked-setter name slot)
    (%make-closure (%make-envt '() slot name)
		   $unchecked-setter))

(define-macro (%make-checked-setter name slot type)
    (%make-closure (%make-envt '() slot type name)
		   $checked-setter))

(%define-glue $getter
{
    if (arg_count_reg != 1)
    {
      scheme_error( "~a: Expected exactly one arg, got ~d\n",
		    2,
		    LEXREF0(1),
		    int2fx(arg_count_reg) );
    }
    REG0 = gvec_read( REG0, FXWORDS_TO_RIBYTES( LEXREF0(0) ) );
    RETURN(1);
})

(define-macro (%make-getter name slot)
    (%make-closure (%make-envt '() slot name)
		   $getter))

(export %make-getter %make-unchecked-setter %make-checked-setter
        $getter $unchecked-setter $checked-setter)

