#|
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
|#
; Accessors and Setters
; ---------------------

(define-syntax (method-specializers method)
    (%gvec-read method 0))

(define-syntax (method-key-class method)
    (car (method-specializers method)))

(define-syntax (method-proc method)
    (%gvec-read method 1))

;; shared structure for gfe's

(define-syntax (gfe-methods gfe)
    (%gvec-read gfe 2))

(define-syntax (gfe-name gfe)
    (%gvec-read gfe 3))

(define-syntax (gfe->gf gfe)
    (%gvec-read gfe 4))


;; non-shared structure

(define-syntax (std-gfe-set-method-cache! gfe c)
     (%gvec-write gfe 1 c))

(define-syntax (std-gfe-set-methods! gfe m)
     (%gvec-write gfe 2 m))

(define-syntax (std-gfe-method-cache gfe)
     (%gvec-read gfe 1))

(define-syntax (std-gfe-methods gfe)
     (gfe-methods gfe))

(define-syntax  (std-gfe-name gfe)
    (%gvec-read gfe 3))

(define-syntax (std-gfe->gf gfe)
    (%gvec-read gfe 4))

;;

(define-syntax (fast-gfe-position gfe)
    (%gvec-read gfe 1))
    
(define-syntax (fast-gfe-methods gfe)
    (gfe-methods gfe))
    
(define-syntax (fast-gfe-cached-classes gfe)
    (%gvec-read gfe 5))
    
(define-syntax (fast-gfe-trap gfe)
    (%gvec-read gfe 6))

(define-syntax (fast-gfe-set-methods! gfe value)
    (%gvec-write gfe 2 value))

(define-syntax (fast-gfe-set-cached-classes! gfe value)
    (%gvec-write gfe 5 value))

;; The meta-method environment

(define-syntax (mme-find-method mme)
    (%gvec-read mme 1))

(define-syntax (mme-add-method mme)
    (%gvec-read mme 2))

(define-syntax (mme-remove-method mme)
    (%gvec-read mme 3))

(define-syntax (mme-remove-all-methods mme)
    (%gvec-read mme 4))


;; Converters

(define-syntax (gf->gfe gf)
  (%gvec-read gf 0))

(define-syntax (gfe->mme gfe)
  (%gvec-read gfe 0))

