#|
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
|#
(if (number? *tag*)
    (set! *tag* (number->string *tag*)))
    
(format #t "*** Preparing to build with tag ~s ***\n" *tag*)

(load "ezc.scm")

(define bi #f)
(define tbls #f)
(define scmio #f)
(define oslib #f)
(define usrlib #f)
(define repl #f)

;;(define *tag* "1")
(if (number? *tag*)
    (set! *tag* (number->string *tag*)))
    
(format #t "*** Building with tag \"~a\" ***\n" *tag*)

(define (append-tag str)
  (string-append str *tag*))

;; setting this causes all monotones output through
;; display-some-monotones to be written the this port

(set! *virt-asm-profile* (open-output-file "virtasms.dat"))

(fluid-let ((*warn-unbound-var-ref* #t))

    (set! bi (load-boot-module-in "bltin" (append-tag "bltin_m")))
    (update bi)
    
    (set! tbls (load-boot-module-in "tables" (append-tag "tables_m")))
    (update tbls)
    
    (set! scmio (load-boot-module-in "scmio" (append-tag "scmio_m")))
    (update scmio)
    
    (set! oslib (load-boot-module-in "oslib" (append-tag "oslib_m")))
    (update oslib)
    
    (set! usrlib (load-boot-module-in "usrlib" (append-tag "usrlib_m")))
    (update usrlib)
    
    (set! repl (load-boot-module-in "repl" (append-tag "repl_m")))
    (update repl))

(if *virt-asm-profile*
    (close-output-port *virt-asm-profile*))

(save-system-image (append-tag "system.img") bi tbls scmio oslib usrlib repl)
(%exit 0)
