#|
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
|#
(define (make-template-stub)
    ;(make-template 0 0 '())
    (cons '#uninit name))

(define (compile-template name formals body lex-envt dyn-envt)
    (if *pre-load*
	(begin
	    (ct-format #t "compiling stub: ~a\n" name)
	    (make-template-stub))
	(if (and (pair? body)
		    (eq? (car body) 'raw:))
	    (compile-template/raw name formals (cdr body) lex-envt dyn-envt)
	    (compile-template/normal name formals body lex-envt dyn-envt))))

(define (compile-template/normal name formals body lex-envt dyn-envt)
    (let* ((code (compile/procedure name 
				    formals
				    body
				    lex-envt
				    dyn-envt 
				    #f))
	    (code-context (make-code-ctx))
	    (insns (code-gen-procedure code '() code-context)))
	(template-within-part
		name
		(count-vinsns insns)
		(write-vinsns name insns)
		(code-ctx-literals code-context))))

(define (compile-template/raw name formals body lex-envt dyn-envt)
    (let ((literals '())
	  (envt '()))

	(if (not *current-part*)
	    (new-part!))

	(if (eq? (car body) 'literals:)
	    (begin
		(set! literals
		    (map
			(lambda (l)
			    (if (and (pair? l)
				     (eq? (car l) '&))
				(ensure-tl-var lex-envt
						(cadr l))
				(eval l (the-top-level lex-envt))))
			(cadr body)))
		(set! body (cddr body))))

	(if (and (null? (cdr body))
		 (not (pair? (car body))))
	    (set! body (list 
			    (list 
			    (string-append
				(c-ify (object->string name))
				"_"
				(number->string 
				    (length 
					(link-table 
					    *current-part*)))
				"_00")
			    (car body)))))

	(ct-format #t "declaring raw glue: template ~a\n" name)
	(c-compile/%define-glue-template name formals body literals)))
