#|
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
|#
(%use hacker eval pathname compiler ctc-prims os)

(load "rawtype.scm")
(load "ezcmp.scm")

(define (lookaside-closure code)
    (lambda (rt-envt)
	(let* ((x (%ctc-eval rt-envt code))
	       (y (assq x *shadows*)))
	    (if y
		(force (cdr y))
		x))))

    
(define-method gen-nctc ((self <ic-call>) ct-envt)
    (let ((fn (lookaside-closure (gen-nctc (function self) ct-envt)))
	  (args (gen-nctc (args self) ct-envt)))
	(nctc-wrap %combo fn args)))

(define-method gen-nctc ((self <ic-root-ref>) ct-envt)
    (let ((root-var (var self)))
	(ct-format #t "gen-nctc <ic-root-ref>: ~a is ~a.~d (USING VALUE)\n"
		      (name (var self))
		      (module root-var)
		      (slot root-var))
	(lambda (rt-envt)
	    (value root-var))))
	    
(define-method gen-nctc ((self <ic-root-set>) ct-envt)
    (let ((root-var (var self)))
	(ct-format #t "gen-nctc <ic-root-set>: ~a is ~a.~d (NOT IMPL)\n"
		      (name (var self))
		      (module root-var)
		      (slot root-var))
	(abort 'gen-nctc "<ic-root-set> not supported")))

(define new-subclass? subclass?)

; now HERE is a load-order dependency:
; we have already loaded something like this (util/patch), 
; and used it's definitions
; in loading ezc, but we want these definitions for use
; BY the program.

(load "../bob2/rw_igfs.scm")

;  after setting compile-optimized-loops, we can no longer
;  compile CTC code, because the CTC back end doesn't know
;  about <ic-loop> icode

(set-compile-optimized-loops! #t)
