#|
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
|#
; (%call ("foo" (obj raw-bool) => raw-bool) x y)
; (%call ("print" (obj)) x)

(define *special-types* #f)

(define (get-special-types)
    (if (not *special-types*)
	(set! *special-types*
	      (list (cons '<obj> <Object>)
		    (cons '<raw-bool> <raw-bool>)
		    (cons '<raw-float> <raw-float>)
		    (cons '<raw-str> <raw-str>)
		    (cons '<raw-int> <raw-int>)
		    (cons '<raw-int-bytes> <raw-int-bytes>))))
    *special-types*)

(define (compile/prim-call sf form lex-envt dyn-envt mode)

    (define (name->type name)
	(let ((s (assq name (get-special-types))))
	    (if s
		(cdr s)
		(lookup-type name lex-envt))))
	
    (let ((fn-info (cadr form))
    	  (args (compile/multi (cddr form) lex-envt dyn-envt 'value)))
	(if (null? (cddr fn-info))
	    ; a procedure -- ie, no return value
	    (begin
		(if (not (eq? mode 'effect))
		    (warning "(%call ~s) used in value-expecting position"
		    	     (car fn-info)))
		(make <ic-call-prim>
		    function: (car fn-info)
		    args: args
		    mode: mode
		    return-types: '()
		    arg-types: (map name->type (cadr fn-info))))
		
	    ; a function -- returns something
	    (make <ic-call-prim>
		function: (car fn-info)
		args: args
		mode: mode
		return-types: (list (name->type (cadddr fn-info)))
		arg-types: (map name->type (cadr fn-info))))))

(define (compile/prim-expr sf form lex-envt dyn-envt mode)
    (make <ic-prim-expr>
	expr: (caddr form)
	mode: mode
	return-types: (list (lookup-type (cadr form) lex-envt))))

(define (compile/cast sf form lex-envt dyn-envt mode)
    (let ((ic (make <ic-multi> arg-list: (list (compile (caddr form) 
							lex-envt 
							dyn-envt 
							'value))
				mode: mode)))
	(set-return-types! ic (list (lookup-type (cadr form) lex-envt)))
	(format #t "compile/cast: ~s\n" form)
	(print ic)
	ic))
