#|
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
|#
(%use dynamic-linking)

(define (make-sysload-defs)
    (let ((table (make-table string=? string->hash)))
	(for-each
	    (lambda (i) 
		(table-insert! table (car i) (cdr i)))
	    (list
		(cons "<Object>" <Object>)
		(cons "<<Class>>" <<Class>>)
		(cons "<String>" <String>)
		(cons "<Vector>" <Vector>)
		(cons "<Symbol>" <Symbol>)
		(cons "<Pair>" <Pair>)
		(cons "<Closure>" <Closure>)
		(cons "<Template>" <Template>)
		(cons "<TopLevelVar>" <TopLevelVar>)
		(cons "<TopLevelEnvt>" <TopLevelEnvt>)
		(cons "<BindingEnvt>" <BindingEnvt>)))
	table))

(define (dynamic-load-module lookup name path image-path)
    (let ((dlf (open-dynamic-load path)))
	(if dlf
	    (let ((md (dynamic-load-lookup 
			    dlf 
			    (string-append "_module_" 
					   (symbol->string name)))))
		(install-module md)
		(close-dynamic-load dlf)
		(dynamic-load-image lookup image-path))
	    (abort 'dynamic-load "could not load ~s" path))))

(define (dynamic-load-image lookup path)
    (let ((x (%load-image path (make-sysload-defs))))
	(format #t "inits: ~s\n" (vector-ref x 0))
	(for-each
	    (lambda (init)
		(init))
	    (vector-ref x 0))
	(format #t "defs: ~s\n" (vector-ref x 1))
	(for-each
	    (lambda (def)
		(%gvec-write (lookup (car def)) 1 (cdr def)))
	    (vector-ref x 1))))

