/*
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
*/
#ifndef _H_HASHMAIN
#define _H_HASHMAIN

#include "obj.h"


obj stringtable_lookup( obj table, obj hash, obj str );
obj stringtable_insert( obj table, obj hash, obj str, obj value );
obj stringtable_remove( obj table, obj hash, obj str );

obj cistringtable_lookup( obj table, obj hash, obj str );
obj cistringtable_insert( obj table, obj hash, obj str, obj value );
obj cistringtable_remove( obj table, obj hash, obj str );

obj objecttable_lookup( obj table, obj hash, obj key );
obj objecttable_insert( obj table, obj hash, obj key, obj value );
obj objecttable_remove( obj table, obj hash, obj key );

/* obj make_primitive_table( void ); */
obj make_table( obj of_table_class, unsigned size_bits );

/* bool hashtable_probe( obj table, obj hash ); */
void hashtable_install( obj table, obj hash, obj key, obj value );
void hashtable_foreach( obj table, void *info, 
			void (*fn)( void *info, obj h, obj key, obj value ) );
obj hashtable_chains( obj table );

bool HASHTABLE_P( obj thing );

obj hashtable_keys_to_list( obj table );
obj hashtable_values_to_list( obj table );

#endif /* _H_HASHMAIN */
