/*
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
*/
#ifndef _H_HTSTRUCT
#define _H_HTSTRUCT

#include "smemory.h"

#define BUCKET_CAPACITY		(8)

#define HASHTABLE_DIRECTORY	SLOT(0)
#define HASHTABLE_DIR_BITS	SLOT(1)
#define HASHTABLE_COUNT		SLOT(2)
#define HASHTABLE_EQ_PROC	SLOT(4)

#define BUCKET_BITS		SLOT(0)
#define BUCKET_OVERFLOW		SLOT(1)

void split_bucket( obj table, obj bucket, obj h, obj k, obj v );
obj make_bucket( int bucket_bits );

#define DIR_SLOT(dir,hash) (FXWORDS_TO_RIBYTES(hash)&(SIZEOF_PTR(dir)-SLOT(1)))

#define read_dir(dir,hash) gvec_read(dir,DIR_SLOT(dir,hash))
#define write_dir(dir,hash,v) gvec_write(dir,DIR_SLOT(dir,hash),v)

#define HASH_SLOT(base_offset) ((base_offset))
#define KEY_SLOT(base_offset) ((base_offset)+SLOT(BUCKET_CAPACITY))
#define VALUE_SLOT(base_offset) ((base_offset)+2*SLOT(BUCKET_CAPACITY))

#define read_bucket_hash(bucket,index) gvec_read(bucket,HASH_SLOT(index))
#define read_bucket_key(bucket,index) gvec_read(bucket,KEY_SLOT(index))
#define read_bucket_value(bucket,index) gvec_read(bucket,VALUE_SLOT(index))

#define write_bucket_hash(bucket,index,h) gvec_write_non_ptr(bucket,\
							     HASH_SLOT(index),\
							     h)
#define write_bucket_key(bucket,index,k) gvec_write(bucket,KEY_SLOT(index),k)
#define write_bucket_value(bucket,i,v) gvec_write(bucket,VALUE_SLOT(i),v)

/* incr/decr the table-size field */

#define change_count(ht,fn) gvec_write_non_ptr(ht,\
					       HASHTABLE_COUNT,\
					       fn(gvec_read(ht,\
							    HASHTABLE_COUNT)))
#define inserting_one(ht) change_count(ht,ADD1)
#define removing_one(ht) change_count(ht,SUB1)

#endif /* _H_HTSTRUCT */
