/*
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
*/
/* a very primitive SaveQueue implementation */

/* network canonicalization function
   (in case it's not PLATFORM_IS_BIG_ENDIAN) */

typedef void *ncanonicalize_fn( void * );


struct SaveQueue_item {
    struct SaveQueue_item *next;
    char data[4];
};

typedef struct {
    struct SaveQueue_item *front;
    struct SaveQueue_item *tail;
    unsigned item_size;
    ncanonicalize_fn *netcanon_fn;
} SaveQueue;

typedef struct {
    SaveQueue *q;
    struct SaveQueue_item *p;
} SaveQueueIterator;

void init_queue( SaveQueue *q, unsigned item_size, ncanonicalize_fn *nc );
void *enqueue_item( SaveQueue *q );

void init_queue_state( SaveQueueIterator *state, SaveQueue *q );
const void *dequeue_item( SaveQueueIterator *state );

unsigned fwrite_queue_contents( SaveQueue *q, FILE *f );
void free_queue( SaveQueue *q );
