#|
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
|#
(define (scandir path)
    (%call ("os_scan_directory" (<raw-str>) => <obj>) path))

(define (getwd)
    (%call ("os_getwd" () => <obj>)))

(define (setwd! path)
    (%call ("os_setwd" (<raw-str>)) path)
    (values))

(define (stat path)
    (%call ("os_file_status" (<raw-str> <obj>) => <obj>) path <Time>))

(define (file-exists? path)
    (%call ("os_file_exists_p" (<raw-str>) => <raw-bool>) path))

(define-syntax stat-mode 
    (syntax-form (stat)
	(vector-ref stat 5)))

(define (stat-directory? stat)
    (not (eq? (bitwise-and (stat-mode stat) 16384) 
	      0)))

(define (stat-access? stat entity mode)
    (not (eq? (bitwise-and (stat-mode stat)
			  (bit-shift-left
			    (case mode
				((read) 4)
				((write) 2)
				((execute) 1)
				(else (abort 'stat-access? 
					     "Bad stat mode: ~a" mode)))
			    (case entity
				((owner) 6)
				((group) 3)
				((world) 0)
				(else (abort 'stat-access? 
					     "Bad stat entity: ~a" entity)))))
	      0)))

(export scandir getwd setwd! stat file-exists? stat-directory? stat-access?)
