/*
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
*/
#include "runtim.h"
#include "schemedl.h"

obj scheme_dl_lookup( obj dlfile, obj link_symbol_name )
{
void *s;

    s = resolve_link_symbol( OBJ_TO_RAW_PTR(dlfile), 
			     string_text(link_symbol_name) );
    if (s)
	return RAW_PTR_TO_OBJ(s);
    return FALSE_OBJ;
}

obj scheme_dl_load( obj objfile )
{
void *p = dynamic_link_file( string_text(objfile) );
obj x;

    if (!p)
	return FALSE_OBJ;
    x = OBJ((UINT_32)p);
    assert( OBJ_ISA_FIXNUM(x) );
    return x;
}

void scheme_dl_done_loading( obj dlfile )
{
    done_resolving( OBJ_TO_RAW_PTR(dlfile) );
}
