/*
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
*/
#ifndef _H_SOCKS
#define _H_SOCKS

#include "obj.h"

obj sock_open_named_socket( obj name, bool async );
void sock_close_named_socket( obj named_socket );

obj sock_connect_to_name( obj host_id, obj name, bool async );
obj sock_accept_connection( obj named_socket, bool async );

obj sock_hostname_to_hostid( obj hostname );
obj sock_hostid_to_hostname( obj hostid );
bool sock_hostid_eq( obj hostid1, obj hostid2 );

/* items is a list of objects returned from
   sock_open_named_socket, sock_connect_to_name,
   or sock_accept_connection with async = YES
*/

obj sock_collect_data( obj items );

void sock_write( obj connection, const char *text, UINT_32 length );

/* sock_read should return 0 on EOF */

UINT_32 sock_read( obj connection, char *buffer, UINT_32 max_len );
void sock_close_connection( obj connection );

#endif /* _H_SOCKS */

