/*
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
*/
#include <stdio.h>
#include <sys/ldr.h>
#include "schemedl.h"
#include "linktype.h"

typedef struct export_table *module_init_fn( void );

void *resolve_link_symbol( void *info, const char *sym )
{
struct export_table *t = (struct export_table *)info;

    assert(t);
    while (t->name)
      {
	if (strcmp(sym,t->name) == 0)
	  return t->value;
	t++;
      }
    return NULL;
}

void *dynamic_link_file( const char *path )
{
module_init_fn *entry_fn;

  /* "." is the library path */

  entry_fn = (module_init_fn *)load( (char *)path, 1, "." );

  if (entry_fn)
    return entry_fn();
  else
    return NULL;
}

void done_resolving( void *info )
{
}

void init_dynamic_link( const char *argv0 )
{
}
