/*
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
*/
#include "runtim.h"

static obj socks_not_implemented( void )
{
  scheme_error( "socket library not implemted\n", 0 );
  return FALSE_OBJ;
}

obj sock_open_named_socket( obj name, bool async )
{
  return socks_not_implemented();
}

void sock_close_named_socket( obj named_socket )
{
  socks_not_implemented();
}


obj sock_connect_to_name( obj host_id, obj name, bool async )
{
  return socks_not_implemented();
}

obj sock_accept_connection( obj named_socket, bool async )
{
  return socks_not_implemented();
}

obj sock_hostname_to_hostid( obj host_name )
{
  return socks_not_implemented();
}

obj sock_hostid_to_hostname( obj hostid )
{
  return socks_not_implemented();
}

bool sock_hostid_eq( obj hostid1, obj hostid2 )
{
  abort();  /* should never get here, because you are only
	       allowed to compare things that others of these
	       functions may have returned, and those functions
	       never return */
  return NO;
}

void sock_write( obj connection, const char *text, UINT_32 length )
{
  abort();
}

UINT_32 sock_read( obj connection, char *buffer, UINT_32 max_len )
{
  abort();
  return 0;
}

void sock_close_connection( obj connection )
{
  abort();
}

obj sock_collect_data( obj items )
{
  return NIL_OBJ;
}
