/*
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
*/
#include "runtim.h"

static obj oslib_ni( void )
{
    scheme_error( "OS library function not supported", 0 );
    return FALSE_OBJ;
}

const char *os_getenv( const char *key )
{
    return NULL;
}

obj os_scan_directory( const char *path )
{
    return oslib_ni();
}

obj os_getwd( void )
{
    return oslib_ni();
}

obj os_getpid( void )
{
    return oslib_ni();
}

obj os_invoke( obj command )
{
    return oslib_ni();
}

obj os_error_string( int rc )
{
    return oslib_ni();
}

obj os_get_resource_usage( obj i_class )
{
    return oslib_ni();
}

obj os_make_directory( const char *path )
{
    return oslib_ni();
}

obj os_file_seek( obj file, UINT_32 offset )
{
    return oslib_ni();
}

obj os_file_read( obj file, obj bvec_class, UINT_32 bytes )
{
    return oslib_ni();
}

obj os_file_write( obj file, obj data )
{
    return oslib_ni();
}

obj os_open_file( const char *path,
		  bool read_p, bool write_p, bool create_p, 
		  bool append_p, bool nonblock_p )
{
    return oslib_ni();
}

bool os_file_exists_p( const char *path )
{
FILE *f = fopen( path, "r" );

    if (f)
      {
	fclose(f);
	return YES;
      }
    return NO;
}

obj os_file_status( const char *path, obj t_class )
{
    return oslib_ni();
}

void os_setwd( const char *path )
{
    oslib_ni();
}

obj os_fork( void )
{
    return oslib_ni();
}

int os_wait( obj child )
{
    oslib_ni();
    return 0;
}

obj os_fork_wait( void )
{
    return oslib_ni();
}

/* convert a unix-standard pathname to local OS format */

obj os_path( obj path )
{
    return path;
}

/* open a file using unix-std pathnames */

FILE *os_fopen( const char *path, const char *mode )
{
    return fopen( path, mode );
}

obj os_time_now( obj t_class )
{
    return oslib_ni();
}

void os_set_timer( UINT_32 msec )
{
    oslib_ni();
}

UINT_32 os_get_time_remaining( void )
{
    oslib_ni();
    return 0;
}


UINT_32 os_halt_timer( void )
{
    oslib_ni();
    return 0;
}

void init_os( void )
{
}

obj os_user_config_file( obj basename )
{
    return FALSE_OBJ;
}

obj os_library_path( void )
{
    return NIL_OBJ;
}

UINT_32 os_random( void )
{
    return (rand() << 16) ^ rand();
}

void os_sleep( UINT_32 usec )
{
    oslib_ni();
}

obj os_get_user_info( obj usr )
{
    return oslib_ni();
}

