/*
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
*/
#include "socks.h"
#include "runtim.h"

static void socks_lib_error( const char *fn, int rc )
{
    scheme_error( "SOCKS library error in ~s: rc ~d",
    		  2, make_string(fn), int2fx(rc) );
}



obj sock_open_named_socket( obj name, bool async )
{
    oslib_error( "sock_open_named_socket", OSLIB_NOT_IMPLEMENTED );
    return FALSE_OBJ;
}

void sock_close_named_socket( obj named_socket )
{
    oslib_error( "sock_close_named_socket", OSLIB_NOT_IMPLEMENTED );
}


obj sock_connect_to_name( obj host_id, obj name, bool async )
{
    oslib_error( "sock_connect_to_name", OSLIB_NOT_IMPLEMENTED );
    return FALSE_OBJ;
}


obj sock_accept_connection( obj named_socket, bool async )
{
    oslib_error( "sock_accept_connection", OSLIB_NOT_IMPLEMENTED );
    return FALSE_OBJ;
}


obj sock_hostname_to_hostid( obj host_name, obj *aliases )
{
    oslib_error( "sock_hostname_to_hostid", OSLIB_NOT_IMPLEMENTED );
    return FALSE_OBJ;
}


obj sock_hostid_to_hostname( obj hostid, obj *aliases )
{
    oslib_error( "sock_hostid_to_hostname", OSLIB_NOT_IMPLEMENTED );
    return FALSE_OBJ;
}


bool sock_hostid_eq( obj hostid1, obj hostid2 )
{
    oslib_error( "sock_hostid_eq", OSLIB_NOT_IMPLEMENTED );
    return NO;
}




void sock_write( obj connection, const char *text, UINT_32 length )
{
    oslib_error( "sock_write", OSLIB_NOT_IMPLEMENTED );
}


UINT_32 sock_read( obj connection, char *buffer, UINT_32 max_len )
{
    oslib_error( "sock_read", OSLIB_NOT_IMPLEMENTED );
    return 0;
}


void sock_close_connection( obj connection )
{
    oslib_error( "sock_close_connection", OSLIB_NOT_IMPLEMENTED );
}

obj sock_collect_data( obj items )
{
    oslib_error( "sock_collect_data", OSLIB_NOT_IMPLEMENTED );
    return FALSE_OBJ;
}

