#|
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
|#
;; parses expressions of the form [n1 n2 ...]

(define *fav-expr* '(#\[
		     (or ((* #\space)
			  (n1 = (+ (or (#\0 ... #\9) #\.)))
			  (* ((+ #\space)
			      (n2 = (+ (or (#\0 ... #\9) #\.)))))
			  (* #\space))
			 (* #\space))
		     #\]))

(define fav (regex->exact-matcher *fav-expr*))


(define *rx1* '(#\( (foo = (+ (#\0 ... #\9))) #\)))

(define rx1 (regex->any-matcher *rx1*))

(format #t "match result = ~s\n" (rx1 "This is a (54) test"))
(format #t "match result = ~s\n" (rx1 "This () is a (99) test"))

(verify equal? (rx1 "This () is a (99) test")
	       '#(((foo . "99")) 13 17))

(verify equal? (rx1 "This is a (54) test")
	       '#(((foo . "54")) 10 14))

(verify equal? (rx1 "This is a (nop) test")
	       #f)

