#|
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
|#
(define (arg-frame? x)
    (if (vector? x)
	(procedure? (vector-ref x 0))
	#f))

(define *suppress-templates* '())

(define (suppress? argf)
    (if (null? *suppress-templates*)
	(set! *suppress-templates*
	      (list %if %multi %combo %literal %bind %seq
	      	    %lex-set! %tl-set! %lambda %root-ref
		    %root-set!)))
    (if (memq (%gvec-read (vector-ref argf 0) 1) *suppress-templates*)
	#t
	#f))

(define (bt)
    (let ((port (current-output-port)))
	(let loop ((i 0) (s (%dynamic-state-ref)))
	    (if (pair? s)
		(begin
		    (if (arg-frame? (car s))
			(if (not (suppress? (car s)))
			    (let* ((v (car s))
				    (n (vector-length v)))
				(format port " [~d] : " i)
				(write (vector-ref v 0) port)
				(newline port)
				(let loop ((j 1))
				    (if (not (eq? j n))
					(begin
					    (format port 
						"      with [~d] = ~a\n"
						(sub1 j)
						(object->bounded-string 
						    59 
						    (vector-ref v j)))
					    (loop (add1 j)))))))
			(begin
			    (format port " (~d) : " i)
			    (display (object->bounded-string 68 (car s)) port)
			    (newline port)))
		    (loop (add1 i) (cdr s)))))))
