/*
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
*/
#include "repl_p.h"

/* Link file for the repl module */

#define NUM_ROOTS (1)
obj repl_root_vector[NUM_ROOTS];

#ifdef PROVIDE_ROOT_NAMES
static struct root_info roots[] = {
    { 0, NULL } };
#else /* PROVIDE_ROOT_NAMES */
#define roots ((struct root_info *)0)
#endif /* PROVIDE_ROOT_NAMES */
extern struct part_descr repl_part_trglue;
extern struct part_descr repl_part_trface1;
extern struct part_descr repl_part_trface;
extern struct part_descr repl_part_trqueue;
extern struct part_descr repl_part_envts;
extern struct part_descr repl_part_formals;
extern struct part_descr repl_part_sforms5;
extern struct part_descr repl_part_sforms4;
extern struct part_descr repl_part_sforms3;
extern struct part_descr repl_part_sforms2;
extern struct part_descr repl_part_sforms1;
extern struct part_descr repl_part_sforms;
extern struct part_descr repl_part_bdgs2;
extern struct part_descr repl_part_bdgs1;
extern struct part_descr repl_part_bdgs;
extern struct part_descr repl_part_types;
extern struct part_descr repl_part_gen_ctc3;
extern struct part_descr repl_part_gen_ctc2;
extern struct part_descr repl_part_gen_ctc1;
extern struct part_descr repl_part_gen_ctc;
extern struct part_descr repl_part_icode4;
extern struct part_descr repl_part_icode3;
extern struct part_descr repl_part_icode2;
extern struct part_descr repl_part_icode1;
extern struct part_descr repl_part_icode;
extern struct part_descr repl_part_message;
extern struct part_descr repl_part_mainc2;
extern struct part_descr repl_part_mainc1;
extern struct part_descr repl_part_mainc;
extern struct part_descr repl_part_macros1;
extern struct part_descr repl_part_macros;
extern struct part_descr repl_part_cmdloop2;
extern struct part_descr repl_part_cmdloop1;
extern struct part_descr repl_part_cmdloop;
extern struct part_descr repl_part_usrenvt2;
extern struct part_descr repl_part_usrenvt1;
extern struct part_descr repl_part_usrenvt;
extern struct part_descr repl_part_defs1;
extern struct part_descr repl_part_defs;
extern struct part_descr repl_part_mktlvs7;
extern struct part_descr repl_part_mktlvs6;
extern struct part_descr repl_part_mktlvs5;
extern struct part_descr repl_part_mktlvs4;
extern struct part_descr repl_part_mktlvs3;
extern struct part_descr repl_part_mktlvs2;
extern struct part_descr repl_part_mktlvs1;
extern struct part_descr repl_part_mktlvs;
extern struct part_descr repl_part_backtrac;
extern struct part_descr repl_part_replexc;
extern struct part_descr repl_part_rw_igfs4;
extern struct part_descr repl_part_rw_igfs3;
extern struct part_descr repl_part_rw_igfs2;
extern struct part_descr repl_part_rw_igfs1;
extern struct part_descr repl_part_rw_igfs;
extern struct part_descr repl_part_smacro;
extern struct part_descr repl_part_help;
extern struct part_descr repl_part_start1;
extern struct part_descr repl_part_start;
extern struct part_descr repl_part_load;
extern struct part_descr repl_part_colonc;
extern struct part_descr repl_part_ccbt;
extern struct part_descr repl_part_usrintro;
extern struct part_descr repl_part_assem10;
extern struct part_descr repl_part_assem9;
extern struct part_descr repl_part_assem8;
extern struct part_descr repl_part_assem7;
extern struct part_descr repl_part_assem6;
extern struct part_descr repl_part_assem5;
extern struct part_descr repl_part_assem4;
extern struct part_descr repl_part_assem3;
extern struct part_descr repl_part_assem2;
extern struct part_descr repl_part_assem1;
extern struct part_descr repl_part_assem;

static struct part_descr *(tab[]) = {
    &repl_part_trglue,
    &repl_part_trface1,
    &repl_part_trface,
    &repl_part_trqueue,
    &repl_part_envts,
    &repl_part_formals,
    &repl_part_sforms5,
    &repl_part_sforms4,
    &repl_part_sforms3,
    &repl_part_sforms2,
    &repl_part_sforms1,
    &repl_part_sforms,
    &repl_part_bdgs2,
    &repl_part_bdgs1,
    &repl_part_bdgs,
    &repl_part_types,
    &repl_part_gen_ctc3,
    &repl_part_gen_ctc2,
    &repl_part_gen_ctc1,
    &repl_part_gen_ctc,
    &repl_part_icode4,
    &repl_part_icode3,
    &repl_part_icode2,
    &repl_part_icode1,
    &repl_part_icode,
    &repl_part_message,
    &repl_part_mainc2,
    &repl_part_mainc1,
    &repl_part_mainc,
    &repl_part_macros1,
    &repl_part_macros,
    &repl_part_cmdloop2,
    &repl_part_cmdloop1,
    &repl_part_cmdloop,
    &repl_part_usrenvt2,
    &repl_part_usrenvt1,
    &repl_part_usrenvt,
    &repl_part_defs1,
    &repl_part_defs,
    &repl_part_mktlvs7,
    &repl_part_mktlvs6,
    &repl_part_mktlvs5,
    &repl_part_mktlvs4,
    &repl_part_mktlvs3,
    &repl_part_mktlvs2,
    &repl_part_mktlvs1,
    &repl_part_mktlvs,
    &repl_part_backtrac,
    &repl_part_replexc,
    &repl_part_rw_igfs4,
    &repl_part_rw_igfs3,
    &repl_part_rw_igfs2,
    &repl_part_rw_igfs1,
    &repl_part_rw_igfs,
    &repl_part_smacro,
    &repl_part_help,
    &repl_part_start1,
    &repl_part_start,
    &repl_part_load,
    &repl_part_colonc,
    &repl_part_ccbt,
    &repl_part_usrintro,
    &repl_part_assem10,
    &repl_part_assem9,
    &repl_part_assem8,
    &repl_part_assem7,
    &repl_part_assem6,
    &repl_part_assem5,
    &repl_part_assem4,
    &repl_part_assem3,
    &repl_part_assem2,
    &repl_part_assem1,
    &repl_part_assem,
    NULL };
struct module_descr module_repl = { "repl", tab,
	NUM_ROOTS, /* num_roots */
	repl_root_vector,
	roots};

