/*
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
*/
/**********************************************
THIS FILE WAS AUTOMATICALLY GENERATED, AND MAY
BE AUTOMATICALLY RE-GENERATED WHEN THE COMPILER
CHANGES.  DO NOT MODIFY THIS FILE BY HAND!
**********************************************/

#define _SUBPROJ_REPL
#define _SCM_TRQUEUE
#define _C_TRQUEUE
#include "repl_p.h"
extern struct part_descr repl_part_trqueue;

/****** function `(write <queue>)' ******/
static char trqueue_writequeue_0_name[] = "(write <queue>)";
#define FUNCTION trqueue_writequeue_0_name

PROLOGUE(trqueue_writequeue_0)

BEGIN_FWD(trqueue_writequeue_0)
  FWD_MONOTONE(trqueue_writequeue_0_0)
END_FWD(trqueue_writequeue_0)

MONOTONE(trqueue_writequeue_0_0)
{
    COUNT_ARGS(2);
    BEGIN_BIND2()
	BIND_ARG(0,REG0);
	BIND_ARG(1,REG1);
    END_BIND
    REG0 = LEXREF0(1) /* port */;
    REG1 = LITERAL(0) /* "#[<Queue> ~s]" */;
    REG2 = gvec_read(LEXREF0(0) /* self */,SLOT(0));
    APPLY(3,TLREF(1) /* format */);
}

EPILOGUE(trqueue_writequeue_0)

BEGIN_BACK(trqueue_writequeue_0)
  BACK_MONOTONE(trqueue_writequeue_0_0)
END_BACK(trqueue_writequeue_0)

static struct function_descr trqueue_writequeue_0_descr = {
	JUMP_TABLE( trqueue_writequeue_0 ),
	trqueue_writequeue_0_name,
	&repl_part_trqueue };
#undef FUNCTION

/****** function `(display <queue>)' ******/
static char trqueue_displayqueue_1_name[] = "(display <queue>)";
#define FUNCTION trqueue_displayqueue_1_name

PROLOGUE(trqueue_displayqueue_1)

BEGIN_FWD(trqueue_displayqueue_1)
  FWD_MONOTONE(trqueue_displayqueue_1_0)
END_FWD(trqueue_displayqueue_1)

MONOTONE(trqueue_displayqueue_1_0)
{
    COUNT_ARGS(2);
    BEGIN_BIND2()
	BIND_ARG(0,REG0);
	BIND_ARG(1,REG1);
    END_BIND
    REG0 = LEXREF0(1) /* port */;
    REG1 = LITERAL(0) /* "#[<Queue> ~s]" */;
    REG2 = gvec_read(LEXREF0(0) /* self */,SLOT(0));
    APPLY(3,TLREF(1) /* format */);
}

EPILOGUE(trqueue_displayqueue_1)

BEGIN_BACK(trqueue_displayqueue_1)
  BACK_MONOTONE(trqueue_displayqueue_1_0)
END_BACK(trqueue_displayqueue_1)

static struct function_descr trqueue_displayqueue_1_descr = {
	JUMP_TABLE( trqueue_displayqueue_1 ),
	trqueue_displayqueue_1_name,
	&repl_part_trqueue };
#undef FUNCTION

/****** function `queue-empty?' ******/
static char trqueue_queue_empty_2_name[] = "queue-empty?";
#define FUNCTION trqueue_queue_empty_2_name

PROLOGUE(trqueue_queue_empty_2)

BEGIN_FWD(trqueue_queue_empty_2)
  FWD_MONOTONE(trqueue_queue_empty_2_0)
END_FWD(trqueue_queue_empty_2)

MONOTONE(trqueue_queue_empty_2_0)
{
    COUNT_ARGS(1);
    REG0 = REG0;
    REG0 = rb_to_bo(NULL_P(gvec_read(REG0 /* q */,SLOT(0))));
    RETURN(1);
}

EPILOGUE(trqueue_queue_empty_2)

BEGIN_BACK(trqueue_queue_empty_2)
  BACK_MONOTONE(trqueue_queue_empty_2_0)
END_BACK(trqueue_queue_empty_2)

static struct function_descr trqueue_queue_empty_2_descr = {
	JUMP_TABLE( trqueue_queue_empty_2 ),
	trqueue_queue_empty_2_name,
	&repl_part_trqueue };
#undef FUNCTION

/****** raw glue `dequeue!' ******/

#define queue REG0

static char trqueue_dequeue_3_name[] = "dequeue!";
#define FUNCTION trqueue_dequeue_3_name

PROLOGUE(trqueue_dequeue_3)

BEGIN_FWD(trqueue_dequeue_3)
  FWD_MONOTONE(dequeue_loop)
  FWD_MONOTONE(dequeue_prep_try_again)
END_FWD(trqueue_dequeue_3)

MONOTONE(dequeue_loop)
{
obj front, current_thread = TLREF(1);

    COUNT_ARGS(1);
    if (!OBJ_ISA_PTR(queue) || !EQ(CLASSOF_PTR(queue),LITERAL(2)))
    {
	failed_type_check( LITERAL(3), LITERAL(4), queue, LITERAL(5) );
    }
    front = gvec_read( queue, QUEUE_FRONT );
    if (EQ(front,NIL_OBJ))
    {
	/* install us on the queue's BLOCKED list */
	gvec_write_ptr( queue,
		        QUEUE_BLOCKED,
		        cons( current_thread, 
			      gvec_read( queue, QUEUE_BLOCKED ) ) );
	SAVE_CONT1(dequeue_prep_try_again);
	flush_stack_cache();
	gvec_write( current_thread, THREAD_STATE, continuation_reg );
	
	/* remove us from the ready queue */

	os_halt_timer();	/* turn off the timer
				   (otherwise, we could get a timeout
				   interrupt before the new thread
				   even starts to run!) */
	APPLY(0,TLREF(0));	/* suspend the current thread */
    }
    else
    {
    obj next = pair_cdr(front);
    
	gvec_write( queue, QUEUE_FRONT, next );
	if (EQ(next,NIL_OBJ))
	    gvec_write( queue, QUEUE_BACK, NIL_OBJ );
	REG0 = pair_car(front);
	RETURN(1);
    }
}

MONOTONE(dequeue_prep_try_again)
{
    RESTORE_CONT1();
    BJUMP(1,dequeue_loop);
}

EPILOGUE(trqueue_dequeue_3)

BEGIN_BACK(trqueue_dequeue_3)
  BACK_MONOTONE(dequeue_loop)
  BACK_MONOTONE(dequeue_prep_try_again)
END_BACK(trqueue_dequeue_3)

static struct function_descr trqueue_dequeue_3_descr = {
	JUMP_TABLE( trqueue_dequeue_3 ),
	trqueue_dequeue_3_name,
	&repl_part_trqueue };
#undef FUNCTION

#undef queue

/****** raw glue `enqueue!' ******/

#define queue REG0
#define item REG1

static char trqueue_enqueue_4_name[] = "enqueue!";
#define FUNCTION trqueue_enqueue_4_name

PROLOGUE(trqueue_enqueue_4)

BEGIN_FWD(trqueue_enqueue_4)
  FWD_MONOTONE(enqueue_4_00)
END_FWD(trqueue_enqueue_4)

MONOTONE(enqueue_4_00)
{
obj did_unblock, back;

    COUNT_ARGS(2);
    if (!OBJ_ISA_PTR(queue) || !EQ(CLASSOF_PTR(queue),LITERAL(1)))
    {
	failed_type_check( LITERAL(2), LITERAL(3), queue, LITERAL(4) );
    }
    item = cons( item, NIL_OBJ );
    back = gvec_read( queue, QUEUE_BACK );
    if (EQ(back,NIL_OBJ))
    {
        /* the queue is empty -- so unblock any waiting threads */
	did_unblock = gvec_read( queue, QUEUE_BLOCKED );
	gvec_write_non_ptr( queue, QUEUE_BLOCKED, NIL_OBJ );
	gvec_write_ptr( queue, QUEUE_FRONT, item );
	gvec_write_ptr( queue, QUEUE_BACK, item );
	if (EQ(did_unblock,NIL_OBJ))
	    RETURN0();
	else
	{
	    REG0 = queue;
	    REG1 = did_unblock;
	    APPLY( 2, TLREF(0) );
	}
    }
    else
    {
	/* the queue is not empty -- nobody should be blocked on us */
	gvec_write_ptr( gvec_read( queue, QUEUE_BACK ), SLOT(1), item );
	gvec_write_ptr( queue, QUEUE_BACK, item );
	RETURN0();
    }
}

EPILOGUE(trqueue_enqueue_4)

BEGIN_BACK(trqueue_enqueue_4)
  BACK_MONOTONE(enqueue_4_00)
END_BACK(trqueue_enqueue_4)

static struct function_descr trqueue_enqueue_4_descr = {
	JUMP_TABLE( trqueue_enqueue_4 ),
	trqueue_enqueue_4_name,
	&repl_part_trqueue };
#undef FUNCTION

#undef queue
#undef item


/*** Part Link Table ***/

static struct function_descr *(part_trqueue_tab[]) = {
    &trqueue_writequeue_0_descr,
    &trqueue_displayqueue_1_descr,
    &trqueue_queue_empty_2_descr,
    &trqueue_dequeue_3_descr,
    &trqueue_enqueue_4_descr,
    NULL };
struct part_descr repl_part_trqueue = {
    357837404,
    &module_repl,
    part_trqueue_tab,
    "trqueue",
    0 };
#undef _SUBPROJ_REPL
#undef _SCM_TRQUEUE
#undef _C_TRQUEUE
