/*
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
*/
#include "smemory.h"
#include "allocns.h"

obj make0( obj the_class )
{
obj it = alloc( 0, the_class );

    return it;
}

obj make1( obj the_class, obj value0 )
{
obj it = alloc1( the_class );

    gvec_write_fresh( it, SLOT(0), value0 );
    return it;
}

obj make2( obj the_class, obj value0, obj value1 )
{
obj it = alloc2( the_class );

    gvec_write_fresh( it, SLOT(0), value0 );
    gvec_write_fresh( it, SLOT(1), value1 );
    return it;
}

obj make3( obj the_class, obj value0, obj value1, obj value2 )
{
obj it = alloc3( the_class );

    gvec_write_fresh( it, SLOT(0), value0 );
    gvec_write_fresh( it, SLOT(1), value1 );
    gvec_write_fresh( it, SLOT(2), value2 );
    return it;
}

obj make4( obj the_class, obj value0, obj value1, obj value2,
			  obj value3 )
{
obj it = alloc4( the_class );

    gvec_write_fresh( it, SLOT(0), value0 );
    gvec_write_fresh( it, SLOT(1), value1 );
    gvec_write_fresh( it, SLOT(2), value2 );
    gvec_write_fresh( it, SLOT(3), value3 );
    return it;
}

obj make5( obj the_class, obj value0, obj value1, obj value2,
			  obj value3, obj value4 )
{
obj it = alloc5( the_class );

    gvec_write_fresh( it, SLOT(0), value0 );
    gvec_write_fresh( it, SLOT(1), value1 );
    gvec_write_fresh( it, SLOT(2), value2 );
    gvec_write_fresh( it, SLOT(3), value3 );
    gvec_write_fresh( it, SLOT(4), value4 );
    return it;
}

obj make6( obj the_class, obj value0, obj value1, obj value2,
			  obj value3, obj value4, obj value5 )
{
obj it = alloc6( the_class );

    gvec_write_fresh( it, SLOT(0), value0 );
    gvec_write_fresh( it, SLOT(1), value1 );
    gvec_write_fresh( it, SLOT(2), value2 );
    gvec_write_fresh( it, SLOT(3), value3 );
    gvec_write_fresh( it, SLOT(4), value4 );
    gvec_write_fresh( it, SLOT(5), value5 );
    return it;
}

obj make7( obj the_class, obj value0, obj value1, obj value2,
			  obj value3, obj value4, obj value5,
			  obj value6 )
{
obj it = alloc7( the_class );

    gvec_write_fresh( it, SLOT(0), value0 );
    gvec_write_fresh( it, SLOT(1), value1 );
    gvec_write_fresh( it, SLOT(2), value2 );
    gvec_write_fresh( it, SLOT(3), value3 );
    gvec_write_fresh( it, SLOT(4), value4 );
    gvec_write_fresh( it, SLOT(5), value5 );
    gvec_write_fresh( it, SLOT(6), value6 );
    return it;
}

obj make8( obj the_class, obj value0, obj value1, obj value2,
			  obj value3, obj value4, obj value5,
			  obj value6, obj value7 )
{
obj it = alloc8( the_class );

    gvec_write_fresh( it, SLOT(0), value0 );
    gvec_write_fresh( it, SLOT(1), value1 );
    gvec_write_fresh( it, SLOT(2), value2 );
    gvec_write_fresh( it, SLOT(3), value3 );
    gvec_write_fresh( it, SLOT(4), value4 );
    gvec_write_fresh( it, SLOT(5), value5 );
    gvec_write_fresh( it, SLOT(6), value6 );
    gvec_write_fresh( it, SLOT(7), value7 );
    return it;
}

obj make9( obj the_class, obj value0, obj value1, obj value2,
			  obj value3, obj value4, obj value5,
			  obj value6, obj value7, obj value8 )
{
obj it = alloc9( the_class );

    gvec_write_fresh( it, SLOT(0), value0 );
    gvec_write_fresh( it, SLOT(1), value1 );
    gvec_write_fresh( it, SLOT(2), value2 );
    gvec_write_fresh( it, SLOT(3), value3 );
    gvec_write_fresh( it, SLOT(4), value4 );
    gvec_write_fresh( it, SLOT(5), value5 );
    gvec_write_fresh( it, SLOT(6), value6 );
    gvec_write_fresh( it, SLOT(7), value7 );
    gvec_write_fresh( it, SLOT(8), value8 );
    return it;
}

