/*
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
*/
#ifndef _H_ATRACE
#define _H_ATRACE

#include <sys/time.h>

struct atrace_realt {
    struct timeval realt;
    unsigned	   alloct;
};

struct atrace_alloc {
    unsigned	size;
    unsigned	class;
};

struct atrace_free {
    unsigned	name;
    unsigned	time;
};

struct atrace_record {
    unsigned	alloct;
    unsigned	freet;
    unsigned	class;
    unsigned	size;
    double	real_alloct;
    double	real_freet;
};

#define PART_NAME_LIMIT  (8)
#define FN_NAME_LIMIT  (20)

struct atrace_linktab {
    char	part[PART_NAME_LIMIT];
    char	name[FN_NAME_LIMIT];
    unsigned	num_monotones;		/* this many addrs will follow */
};

struct atrace_exec {
    unsigned	alloct;			/* time at start of execution */
    unsigned	addr;
};

#define CLASS_NAME_LIMIT  (12+16)

struct atrace_class {
    unsigned	class;
    char	name[CLASS_NAME_LIMIT];
};

#ifdef _H_OBJ
void atrace_init( void );
void atrace_flush( int close );

void atrace_did_alloc( POBHeader *p );
void atrace_did_free( gc_obj_addr p );
void atrace_will_execute( jump_addr addr );
#endif
#endif
