/*
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
*/
#ifndef _H_LINKTYPE
#define _H_LINKTYPE

#include "obj.h"

struct module_descr;
struct part_descr;
struct function_descr;

struct part_descr {
    UINT_32		  tag;
    struct module_descr   *in_module;
    struct function_descr **functions;
    const char 		  *name;
    UINT_32		  unswizzled_as;	/* for use during saving */
};

struct function_descr {
    jump_addr 		*monotones;
    const char 		*name;
    struct part_descr   *in_part;
};

struct root_info {
    int			slot;
    const char		*name;
};

struct module_descr {
    const char		*name;
    struct part_descr	**parts;
    unsigned		num_roots;
    obj			*root_vector;
    struct root_info	*roots;
};

typedef void call_gate( void );

struct call_gate_descr {
    const char		*name;
    call_gate		*proc;
};

extern struct module_descr **master_table;
extern struct call_gate_descr call_gates[];

void init_linkage( struct module_descr **initial_table );
void install_module( struct module_descr *m );

struct module_descr *find_module( const char *module );
struct part_descr *find_part( struct module_descr *m, int tag );

#ifdef PLATFORM_AIX
struct export_table {
    char *name;
    void *value;
};
#endif

#endif /* _H_LINKTYPE */
