/*
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
*/
#include "vinsns.h"

#ifndef STACK_CACHE

#ifndef INLINES
#include "stack.ci"
#endif


/************************ Continuations ************************/

void push_cont( jump_addr label, unsigned reg_space )
{
obj pc = alloc( SLOT(CONT_FIXED+reg_space), partcont_class );
    
    gvec_write_fresh( pc, SLOT(0), envt_reg );
    gvec_write_fresh( pc, SLOT(1), literals_reg );
    gvec_write_fresh( pc, SLOT(2), dynamic_state_reg );
    gvec_write_fresh( pc, SLOT(3), continuation_reg );
    gvec_write_fresh_non_ptr( pc, SLOT(4), JUMP_ADDR_TO_OBJ(label) );
    continuation_reg = pc;
}

/*
    Restores a dynamically-determined number of
    argument-passing registers (ie, for use in the
    extremely rare cases when it cannot be determined
    statically -- nb, this only happens when compiling
    to closure-threaded code and on the occasion of
    interrupts) and the continuation register itself
*/

unsigned restore_arb( void )
{
unsigned n = (SIZEOF_PTR(continuation_reg) / sizeof(obj)) - CONT_FIXED;

    restore_cont( n );
    return n;
}

#endif /* STACK_CACHE */
