#|
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
|#
(define-class <EOF> (<Object>))

(define-generic-fn close-input-port)
(define-generic-fn close-output-port)
(define-generic-fn flush-output-port)

(define-generic-fn set-input-port-prompt!)
(define-generic-fn set-input-port-completions!)
(define-generic-fn input-port-prompt)
(define-generic-fn input-port-completions)

(define root: "eof_object" *eof-object*)

(define-generic-fn %char-ready?)
(define-generic-fn %peek-char)
(define-generic-fn %read-char)
(define-generic-fn %read-line)
(define-generic-fn %scan-token)

(define-macro (eof-object? thing)
    (eq? thing *eof-object*))
    
(define-class <Port> (<Object>))

(define-class <InputPort> (<Port>))

(define-class <File-InputPort> (<InputPort>)
    buffer
    c-file
    path)

(define-class <String-InputPort> (<InputPort>)
    source-string
    index)

(define-class <Console-InputPort> (<InputPort>)
    buffer
    index
    (input-port-completions '())
    (input-port-prompt "? " <String>))

(define-class <OutputPort> (<Port>))

(define-class <File-OutputPort> (<OutputPort>)
    c-file
    path)

(define-class <String-OutputPort> (<OutputPort>)
    buffer
    index
    overflow)

(define-class <BoundedString-OutputPort> (<OutputPort>)
    buffer
    index
    escape)

(define-class root: "token_class" <Token> (<Object>) :no-ivar-gfs
    type
    data
    port-state)

(define root: "token_types"  token-type-vector
     '#(<literal>
	<symbol>
	<number>
	<open-paren>
	<open-vector>
	<close-paren>
	<dot>
	<quote>
	<quasiquote>
	<unquote>
	<unquote-splicing>
	<object-ref>))

(define-syntax token-type
    (syntax-form (x)
	(%gvec-read x 0)))

(define-syntax token-data
    (syntax-form (x)
	(%gvec-read x 1)))

(export %char-ready? %peek-char %read-char %scan-token *eof-object*)
(export <Port> <InputPort> <OutputPort>)
(export <File-InputPort> <String-InputPort> 
	<Console-InputPort> <Token>
        <File-OutputPort> <String-OutputPort> <BoundedString-OutputPort>)
	