#|
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
|#
(define (%close-all-input-files)
    (%for-each-input-file close-input-port))
	
(define (%close-all-output-files)
    (%for-each-output-file close-output-port))

(define (%close-all-files)
    (%close-all-input-files)
    (%close-all-output-files))


(define (current-output-port)
    (fluid-ref *output-port* %console-output-port))

(define (current-input-port)
    (fluid-ref *input-port* %console-input-port))

(define (console-output-port)
    %console-output-port)

(define (console-input-port)
    %console-input-port)

(define (open-console-input-port)
    (make <Console-InputPort>))

(define (init-scmio)
    (set! *eof-object* (make <EOF>))
    (set! %console-output-port (%COP-make "*stdout*"))
    (set! %console-input-port (open-console-input-port)))

(define-method set-input-port-prompt! ((self <InputPort>) 
				       (prompt <String>))
    ;; do nothing
    prompt)

(define-method set-input-port-completions! ((self <InputPort>) 
				            completions)
    ;; do nothing
    completions)

(run-named init-scmio)

(define (_eof-object? x)
    (eof-object? x))

(export console-input-port console-output-port 
	open-console-input-port
	set-input-port-prompt!
	set-input-port-completions!
	input-port-prompt
	input-port-completions)

(export read (_eof-object? eof-object?))
(export open-input-file*)

(export close-input-port close-output-port flush-output-port)
(export current-input-port current-output-port)
(export %for-each-output-file %for-each-input-file 
	%close-all-input-files %close-all-output-files 
	%close-all-files)

