#|
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
|#
#|
   This stuff is intended for system and single-user debugging
   only and CAREFUL USE!
|#

(define *user-object-table* #f)
(define *user-id-table* #f)
(define *num-user-objects* 0)

(define (get-user-hash obj)
    (let ((i (table-lookup *user-object-table* obj)))
	(if i
	    i
	    (let ((i *num-user-objects*))
		(set! *num-user-objects* (add1 i))
		(table-insert! *user-object-table* obj i)
		(table-insert! *user-id-table* i obj)
		i))))

(define (find-object-ref i)
    (table-lookup *user-id-table* i))

(define (clear-user-hash)
    (set! *user-object-table* (make-object-table))
    (set! *user-id-table* (make-table eq? integer->hash))
    (set! *num-user-objects* 0)
    *user-id-table*)

(run-named clear-user-hash)

(export clear-user-hash get-user-hash)
