/*
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
*/
#include "privio.h"
#include "bltin_p.h"
#include "scmio_p.h"
#include <stdio.h>
#include "osglue.h"

void FOP_close( obj port )
{
obj cf = gvec_read( port, FOP_CFILE );

    if (!EQ(cf,FALSE_OBJ))
    {
	fclose((FILE*)OBJ_TO_RAW_PTR( cf ));
	gvec_write_non_ptr( port, FOP_CFILE, FALSE_OBJ );
    }
}

void FOP_flush( obj port )
{
obj cf = gvec_read( port, FOP_CFILE );

    if (!EQ(cf,FALSE_OBJ))
    {
	fflush((FILE*)OBJ_TO_RAW_PTR( cf ));
    }
}


void FOP_write( obj port, const char *src, UINT_32 len )
{
FILE *f;

    f = (FILE *)OBJ_TO_RAW_PTR( gvec_read( port, FOP_CFILE ) );
    fwrite( src, 1, len, f );
    /* fflush(f); */
}

obj FOP_fmake( FILE *f, obj name, obj fop_class )
{
    return make2( fop_class, RAW_PTR_TO_OBJ(f), name );
}

obj FOP_make( obj path, obj fop_class )
{
FILE *f;

    f = os_fopen( string_text(path), "w" );
    if (!f)
	return FALSE_OBJ;
    return FOP_fmake( f, path, fop_class );
}

