#|
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
|#
; some support functions...

(define (write-tab4 tab-stop port)
    (let loop ((i tab-stop))
	(if (> i 1)
	    (begin
		(%write-char port #\tab)
		(loop (sub1 (sub1 i))))
	    (if (> i 0)
		(begin
		    (%write-str port "    ")
		    (loop (sub1 i)))))))


(define (write-hex-w/pad num port pad)
    (let ((s (number->string num 16)))
	(let loop ((i (string-length s)))
	    (if (< i pad)
		(begin
		    (%write-char port #\0)
		    (loop (add1 i)))))
	(%write-str port s)))

(define (write-radix num port radix)
    (%write-str port (number->string num radix)))

(define (write-dec num port)
    (%write-int port num))

(define (write-hex num port)
    (write-radix num port 16))

(define (write-oct num port)
    (write-radix num port 8))

(define (write-bin num port)
    (write-radix num port 2))

(export write-radix write-tab4
	write-dec write-hex write-oct write-bin write-hex-w/pad)

