#|
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
|#
(define-syntax using-inport
    (syntax-form (port)
	(if (null? port) 
	    (current-input-port) 
	    (car port))))

(define (open-input-file path)
    (type-check path string? <String>)
    (let ((f (open-input-file* path)))
	(if f
	    f
	    (abort 'open-input-file 
	    	   "could not open input file: ~a" path))))

(define (open-input-string str)
    (type-check str string? <String>)
    (make <String-InputPort> source-string: str index: 0))

(define (read-char . port)
    (%read-char (using-inport port)))

(define (peek-char . port)
    (%peek-char (using-inport port)))

(define (char-ready? . port)
    (%char-ready? (using-inport port)))

(define (scan-token . port)
    (%scan-token (using-inport port)))

(define (read-line . port)
    (%read-line (using-inport port)))

(define (input-port? thing)
    (isa? thing <InputPort>))	;; `isa?' is true for indirect instances, too

(define (console-input-port? thing)
    (isa? thing <Console-InputPort>))

(define (file-input-port? thing)
    (isa? thing <File-InputPort>))

(define (token? thing)
    (isa? thing <Token>))

(export open-input-file open-input-string 
	input-port? file-input-port? console-input-port?
	read-char read-line peek-char char-ready? scan-token)
