/*
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
*/
#include "privio.h"
#include "bltin_p.h"
#include "scmio_p.h"

static inline obj str( obj str_port )
{
    return gvec_read( str_port, SIP_STRING );
}

static inline UINT_32 str_index( obj str_port )
{
    return fx2int( gvec_read( str_port, SIP_INDEX ) );
}

static inline void bump( obj str_port )
{
    gvec_write_non_ptr( 
	str_port,
	SIP_INDEX,
	ADD1( gvec_read( str_port, SIP_INDEX ) )
    );
}

obj SIP_peek_char( obj port )
{
obj text = str(port);
int ix = str_index(port);

    if (ix < string_length(text))
    {
	return MAKE_ASCII_CHAR( string_text(text)[ix] );
    }

    return eof_object;
}

/* R4RS: "If the port is at end of file then char-ready? returns #t"
*/

bool SIP_char_ready_p( obj port )
{
    return YES;
}


obj SIP_read_char( obj port )
{
obj ch;

    ch = SIP_peek_char(port);
    if (!EOF_OBJECT_P(ch))
	bump( port );
    return ch;
}
