/*
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
*/
#ifndef _H_IOPRIV
#define _H_IOPRIV

#include "runtim.h"
#include <stdio.h>

void FP_close( obj file_ptr );	/* file_ptr should be a FILE* */
void FP_flush( obj file_ptr );	/* file_ptr should be a FILE* */

#define FIP_BUFFER		  SLOT(0)
#define FIP_CFILE		  SLOT(1)
#define FIP_PATH		  SLOT(2)

obj FIP_peek_char( obj port );
obj FIP_read_char( obj port );
bool FIP_char_ready_p( obj port );

obj inport_scan_token( obj port, obj (*peek)( obj ), obj (*read)( obj ) );

#define SIP_STRING		  SLOT(0)
#define SIP_INDEX		  SLOT(1)

obj SIP_peek_char( obj port );
obj SIP_read_char( obj port );
bool SIP_char_ready_p( obj port );


#define CIP_BUFFER		  SLOT(0)
#define CIP_INDEX		  SLOT(1)
#define CIP_COMPLETIONS		  SLOT(2)
#define CIP_PROMPT		  SLOT(3)

obj CIP_peek_char( obj port );
obj CIP_read_char( obj port );
bool CIP_char_ready_p( obj port );


#define BSOP_BUFFER		  SLOT(0)
#define BSOP_INDEX		  SLOT(1)
#define BSOP_ESCAPE		  SLOT(2)

bool BSOP_write( obj port, const char *src, UINT_32 len );
obj BSOP_close( obj port );

#define SOP_BUFFER		  SLOT(0)
#define SOP_INDEX		  SLOT(1)
#define SOP_OVERFLOW		  SLOT(2)

void SOP_write( obj port, const char *src, UINT_32 len );
obj SOP_close( obj port );

#define FOP_CFILE		  SLOT(0)
#define FOP_PATH		  SLOT(1)

void FOP_write( obj port, const char *src, UINT_32 len );
void FOP_close( obj port );
void FOP_flush( obj port );


#define EOF_OBJECT_P(thing) EQ(thing,eof_object)

const char *read_console_line( obj completions, const char *prompt );

/************************* Input Ports *************************/

obj FIP_make( obj path, obj fip_class );

/************************* Output Ports *************************/

obj BSOP_make( obj using, obj escape );
obj SOP_make( void );
obj FOP_make( obj path, obj fop_class );
obj FOP_fmake( FILE *p, obj pathname, obj fop_class );

void printablize_string( obj str, obj str_index );

#endif /* _H_IOPRIV */
