/*
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
*/
#include "scmio_p.h"

/* Link file for the scmio module */

#define NUM_ROOTS (3)
obj scmio_root_vector[NUM_ROOTS];

#ifdef PROVIDE_ROOT_NAMES
static struct root_info roots[] = {
    { 2, "token-type-vector" },
    { 1, "<token>" },
    { 0, "*eof-object*" },
    { 0, NULL } };
#else /* PROVIDE_ROOT_NAMES */
#define roots ((struct root_info *)0)
#endif /* PROVIDE_ROOT_NAMES */
extern struct part_descr scmio_part_ip_glue;
extern struct part_descr scmio_part_op_glue;
extern struct part_descr scmio_part_outpriv;
extern struct part_descr scmio_part_writers3;
extern struct part_descr scmio_part_writers2;
extern struct part_descr scmio_part_writers1;
extern struct part_descr scmio_part_writers;
extern struct part_descr scmio_part_fmtlang;
extern struct part_descr scmio_part_fmt_rt;
extern struct part_descr scmio_part_pubout;
extern struct part_descr scmio_part_pubin;
extern struct part_descr scmio_part_sscan2;
extern struct part_descr scmio_part_sscan1;
extern struct part_descr scmio_part_sscan;
extern struct part_descr scmio_part_reader;
extern struct part_descr scmio_part_ip_bufr;
extern struct part_descr scmio_part_misc;
extern struct part_descr scmio_part_highio;
extern struct part_descr scmio_part_objref;
extern struct part_descr scmio_part_userport;

static struct part_descr *(tab[]) = {
    &scmio_part_ip_glue,
    &scmio_part_op_glue,
    &scmio_part_outpriv,
    &scmio_part_writers3,
    &scmio_part_writers2,
    &scmio_part_writers1,
    &scmio_part_writers,
    &scmio_part_fmtlang,
    &scmio_part_fmt_rt,
    &scmio_part_pubout,
    &scmio_part_pubin,
    &scmio_part_sscan2,
    &scmio_part_sscan1,
    &scmio_part_sscan,
    &scmio_part_reader,
    &scmio_part_ip_bufr,
    &scmio_part_misc,
    &scmio_part_highio,
    &scmio_part_objref,
    &scmio_part_userport,
    NULL };
struct module_descr module_scmio = { "scmio", tab,
	NUM_ROOTS, /* num_roots */
	scmio_root_vector,
	roots};

