#|
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
|#
(define-macro (%assoc proc test search list)
    (let loop ((l list))
	(if (pair? l)
	    (let ((x (car l)))
		(if (pair? x)
		    (if (test (car x) search)
			x
			(loop (cdr l)))
		    (abort (mquote proc) 
			    "~s not an association at: ~s" 
			    x
			    l)))
	    (if (null? l)
		#f
		(abort (mquote proc) "Not a list at: ~s" l)))))

(define-macro (%member proc test search list)
    (let loop ((l list))
	(if (pair? l)
	    (if (test (car l) search)
		l
		(loop (cdr l)))
	    (if (null? l)
		#f
		(abort (mquote proc) "Not a list at: ~s" l)))))

(define (assq item list)
    (%assoc assq eq? item list))
		
(define (assv item list)
    (%assoc assoc eqv? item list))
    
(define (assoc item list)
    (%assoc assoc equal? item list))
    
(define (memq item list)
    (%member memq eq? item list))

(define (memv item list)
    (%member memv eqv? item list))

(define (member item list)
    (%member member equal? item list))

(export assq assv assoc)
(export memq memv member)
