#|
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
|#
;; this file is a derivative work from
;;
;; Scheme48-0.34 bcomp/usual.scm
;;
;; Copyright (c) 1993, 1994 by Richard Kelsey and Jonathan Rees.


(define (%expand-quasiquote form)
    (expand-quasiquote form 0)
    
(define (make-system-ref sym) sym)

;;  From Scheme48...
;;  adapted 93.11.14 by D.Kolbly
;;  for use in the EasyScheme/RScheme system
;;  (modified only to not use quasiquote itself, so I
;;   could bootstrap it)

#|
(define-rewriter 'quasiquote
  (lambda (x)
    (expand-quasiquote x 0)))
|#

(define (expand-quasiquote x level)
  (descend-quasiquote x level finalize-quasiquote))

(define (finalize-quasiquote mode arg)
  (cond ((eq? mode 'quote) (list 'quote arg))
        ((eq? mode 'unquote) arg)
        ((eq? mode 'unquote-splicing)
         (abort 'quasiquote ",@ in illegal context (~a)" arg))
        (else (cons mode arg))))

(define (descend-quasiquote x level return)
  (cond ((vector? x)
         (descend-quasiquote-vector x level return))
        ((not (pair? x))
         (return 'quote x))
        ((interesting-to-quasiquote? x 'quasiquote)
         (descend-quasiquote-pair x (+ level 1) return))
        ((interesting-to-quasiquote? x 'unquote)
         (cond ((= level 0)
                (return 'unquote (cadr x)))
               (else
                (descend-quasiquote-pair x (- level 1) return))))
        ((interesting-to-quasiquote? x 'unquote-splicing)
         (cond ((= level 0)
                (return 'unquote-splicing (cadr x)))
               (else
                (descend-quasiquote-pair x (- level 1) return))))
        (else
         (descend-quasiquote-pair x level return))))

(define (descend-quasiquote-pair x level return)
  (descend-quasiquote (car x) level
    (lambda (car-mode car-arg)
      (descend-quasiquote (cdr x) level
        (lambda (cdr-mode cdr-arg)
          (cond ((and (eq? car-mode 'quote) (eq? cdr-mode 'quote))
                 (return 'quote x))
                ((eq? car-mode 'unquote-splicing)
                 ;; (,@mumble ...)
                 (cond ((and (eq? cdr-mode 'quote) (null? cdr-arg))
                        (return 'unquote
                                car-arg))
                       (else
                        (return (make-system-ref 'append)
                                (list car-arg (finalize-quasiquote cdr-mode cdr-arg))))))
                (else
                 (return (make-system-ref 'cons)
                         (list (finalize-quasiquote car-mode car-arg)
                               (finalize-quasiquote cdr-mode cdr-arg))))))))))

(define (descend-quasiquote-vector x level return)
  (descend-quasiquote (vector->list x) level
    (lambda (mode arg)
      (case mode
        ((quote) (return 'quote x))
        (else (return (make-system-ref 'list->vector)
                      (list (finalize-quasiquote mode arg))))))))

(define (interesting-to-quasiquote? x marker)
  (and (pair? x) (eq? (car x) marker)))

)

(export %expand-quasiquote)
(define-shadow %expand-quasiquote %expand-quasiquote)

