#|
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
|#
(define-syntax (string=?-hash-table-lookup table hash str)
    (%call ("stringtable_lookup" (<obj> <obj> <obj>) => <obj>) 
	    table hash str))

(define-syntax (string=?-hash-table-insert table hash str value)
    (%call ("stringtable_insert" (<obj> <obj> <obj> <obj>) => <obj>) 
	    table hash str value))

(define-syntax (string=?-hash-table-remove table hash str)
    (%call ("stringtable_remove" (<obj> <obj> <obj>) => <obj>) 
	    table hash str))

(define-syntax (string-ci=?-hash-table-lookup table hash str)
    (%call ("cistringtable_lookup" (<obj> <obj> <obj>) => <obj>) 
	    table hash str))

(define-syntax (string-ci=?-hash-table-insert table hash str value)
    (%call ("cistringtable_insert" (<obj> <obj> <obj> <obj>) => <obj>) 
	    table hash str value))

(define-syntax (string-ci=?-hash-table-remove table hash str)
    (%call ("cistringtable_remove" (<obj> <obj> <obj>) => <obj>) 
	    table hash str))

(define-syntax (eq?-hash-table-lookup table hash obj)
    (%call ("objecttable_lookup" (<obj> <obj> <obj>) => <obj>) 
	    table hash obj))

(define-syntax (eq?-hash-table-insert table hash obj value)
    (%call ("objecttable_insert" (<obj> <obj> <obj> <obj>) => <obj>) 
	    table hash obj value))

(define-syntax (eq?-hash-table-remove table hash obj)
    (%call ("objecttable_remove" (<obj> <obj> <obj>) => <obj>) 
	    table hash obj))

(define generic-hash-table-lookup
	(%make <Closure> '() (%template (ctcprims 9403) 0)))
(define generic-hash-table-remove
	(%make <Closure> '() (%template (ctcprims 9403) 1)))
(define generic-hash-table-insert
	(%make <Closure> '() (%template (ctcprims 9403) 2)))


;; (probe is not implemented yet -- faked out)

(define (string=?-hash-table-probe table hash key)
    (if (string=?-hash-table-lookup table hash key)
	#t
	#f))
	
(define (string-ci=?-hash-table-probe table hash key)
    (if (string-ci=?-hash-table-lookup table hash key)
	#t
	#f))
	
(define (eq?-hash-table-probe table hash key)
    (if (eq?-hash-table-lookup table hash key)
	#t
	#f))
	
(define (generic-hash-table-probe table hash key)
    (if (generic-hash-table-lookup table hash key)
	#t
	#f))
