#|
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
|#
;; introspection

(define-generic-function table-hash-function)
(define-generic-function table-equal-function)

(define-generic-function table-size)
(define-generic-function table-keys->list)
(define-generic-function table-values->list)

;;

;(define-class <table> (<object>)
(define-class root: "table_class" <table> (<object>)
    directory
    (directory-bits 4)
    (table-size 0))

;(define-class <table-bucket> (<object>) :no-ivar-gfs
(define-class root: "table_bucket_class" <table-bucket> (<object>)
    bucket-bits
    bucket-overflow)

;(define-syntax (bucket-bits b)
;    (%gvec-read b 0))
    
;(define-syntax (bucket-overflow b)
;    (%gvec-read b 1))
    
;; operations

(define-generic-function table-lookup)
(define-generic-function table-insert!)
(define-generic-function table-remove!)
(define-generic-function table-key-present?)

#|
(define-generic-function key-sequence)		;; DIRM p.129
(define-generic-function element)		;; DIRM p.128
|#

(define-generic-function table-for-each)

(export <table> <table-bucket>)
(export table-lookup table-insert! table-remove! table-key-present?
        table-size table-hash-function table-equal-function)

(export directory-bits)

