#|
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
|#
;(define-class <eq-table> (<table>)
(define-class root: "eq_table_class" <eq-table> (<table>)
    table-hash-function)

(define-method table-key-present? ((self <eq-table>) key)
    (eq?-hash-table-probe self ((table-hash-function self) key) key))

(define-method table-lookup ((self <eq-table>) key)
    (eq?-hash-table-lookup self ((table-hash-function self) key) key))

(define-method table-remove! ((self <eq-table>) key)
    (eq?-hash-table-remove self ((table-hash-function self) key) key))

(define-method table-insert! ((self <eq-table>) key value)
    (eq?-hash-table-insert self ((table-hash-function self) key) key value))

;; introspection

(define-method table-equal-function ((self <eq-table>))
    eq?)



;; tables of integers with NO hashing

(define-class <integer-table> (<table>))

(define-method table-key-present? ((self <integer-table>) key)
    (eq?-hash-table-probe self key key))

(define-method table-lookup ((self <integer-table>) key)
    (eq?-hash-table-lookup self key key))

(define-method table-remove! ((self <integer-table>) key)
    (eq?-hash-table-remove self key key))

(define-method table-insert! ((self <integer-table>) key value)
    (eq?-hash-table-insert self key key value))

;; introspection

(define-method table-equal-function ((self <integer-table>))
    eq?)

(define-method table-hash-function ((self <integer-table>))
    identity)


;; tables of integers WITH hashing

(define-class <hash-integer-table> (<table>))

(define-method table-key-present? ((self <hash-integer-table>) key)
    (eq?-hash-table-probe self (integer->hash key) key))

(define-method table-lookup ((self <hash-integer-table>) key)
    (eq?-hash-table-lookup self (integer->hash key) key))

(define-method table-remove! ((self <hash-integer-table>) key)
    (eq?-hash-table-remove self (integer->hash key) key))

(define-method table-insert! ((self <hash-integer-table>) key value)
    (eq?-hash-table-insert self (integer->hash key) key value))

;; introspection

(define-method table-equal-function ((self <hash-integer-table>))
    eq?)

(define-method table-hash-function ((self <hash-integer-table>))
    integer->hash)
