#|
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
|#
(define (integer->hash (x <fixnum>))
    (ht-assert fixnum? x)
    (%call ("rehash_fixnum" (<obj>) => <obj>) x))

(define-primop (symbol->hash (s <symbol>))
    (ht-assert symbol? s)
    (%gvec-read s 1))

(define-primop (string->hash (s <string>))
    (ht-assert string? s)
    (%call ("hash_string" (<obj>) => <obj>) s))

(define-primop (string-ci->hash (s <string>))
    (ht-assert string? s)
    (%call ("hash_string_ci" (<obj>) => <obj>) s))

;; this function is private...

(define (transient->hash item)
    (%call ("obj_hash" (<obj>) => <obj>) item))

(define (immob->hash item)
    (%call ("obj_hash" (<obj>) => <obj>) item))

(define (identity item)
  item)

(export integer->hash immob->hash symbol->hash string->hash string-ci->hash
	identity)
