#|
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
|#
; these "define-system"'s are necessary to establish
; the identity of the object in our heap image known as <foo>
; to the object already present in the heap at load time

(define-system "<table>" <table>)
(define-system "<string-table>" <string-table>)
(define-system "<string-ci-table>" <string-ci-table>)
(define-system "<object-table>" <object-table>)
(define-system "<eq-table>" <eq-table>)
(define-system "<table-bucket>" <table-bucket>)

(define replacement-table-classes
    (list
	(cons <table> 
	      (make-class <table> (<object>)
		    directory
		    directory-bits
		    table-size))
	(cons <string-table> (make-class <string-table> (<table>)))
	(cons <string-ci-table> (make-class <string-ci-table> (<table>)))
	(cons <object-table> (make-class <object-table> (<table>)))
	(cons <eq-table> (make-class <eq-table> (<table>)
			    table-hash-function))
	(cons <table-bucket>
	      (make-class <table-bucket> (<object>)
		    bucket-bits
		    bucket-overflow))))

(define (init-tables)
    ; we should also set the address_table's hash function
    ; to immob->hash
    (for-each %replace-gvec
	      replacement-table-classes))

(run-named init-tables)

(export <string-table>
        <string-ci-table>
	<eq-table>
	<symbol-table>
	<object-table>
	<generic-table>
	<integer-table>
	<hash-integer-table>)

