#|
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
|#
;(define-class <string-ci-table> (<table>))
(define-class root: "string_ci_table_class" <string-ci-table> (<table>))

(define-method table-key-present? ((self <string-ci-table>) (key <string>))
    (ht-assert string? key)
    (string-ci=?-hash-table-probe self (string-ci->hash key) key))

(define-method table-lookup ((self <string-ci-table>) (key <string>))
    (ht-assert string? key)
    (string-ci=?-hash-table-lookup self (string-ci->hash key) key))

(define-method table-remove! ((self <string-ci-table>) (key <string>))
    (ht-assert string? key)
    (string-ci=?-hash-table-remove self (string-ci->hash key) key))

(define-method table-insert! ((self <string-ci-table>) (key <string>) value)
    (ht-assert string? key)
    (string-ci=?-hash-table-insert self (string-ci->hash key) key value))

;; introspection

(define-method table-hash-function ((self <string-ci-table>))
    string-ci->hash)
    
(define-method table-equal-function ((self <string-ci-table>))
    string-ci=?)

(%define-glue (get-system-symbol-table)
{
    REG0 = symbol_table;
    RETURN(1);
})

(export get-system-symbol-table)
