#|
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
|#
(define-class <symbol-table> (<table>))

(define-method table-key-present? ((self <symbol-table>) (key <symbol>))
    (ht-assert symbol? key)
    (eq?-hash-table-probe self (symbol->hash key) key))

(define-method table-lookup ((self <symbol-table>) (key <symbol>))
    (ht-assert symbol? key)
    (eq?-hash-table-lookup self (symbol->hash key) key))

(define-method table-remove! ((self <symbol-table>) (key <symbol>))
    (ht-assert symbol? key)
    (eq?-hash-table-remove self (symbol->hash key) key))

(define-method table-insert! ((self <symbol-table>) (key <symbol>) value)
    (ht-assert symbol? key)
    (eq?-hash-table-insert self (symbol->hash key) key value))

;; introspection

(define-method table-hash-function ((self <symbol-table>))
    symbol->hash)
    
(define-method table-equal-function ((self <symbol-table>))
    eq?)
