#|
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
|#
(import bltin)

(prologue {
#include "hashfn.h"
#include "hashmain.h"
})

(define-syntax (ht-assert pred expr) ;; until arg-checking is implemented
    (if (not (pred expr))
	(scheme-error "ht-assert (in ~s): (~s ~s) => #f"
		      (*FUNCTION*)
		      (mquote pred)
		      (mquote expr))))

(snarf define-primop-rewriter)

(define-rewriter (define-primop form)
    (define-primop-rewriter form))


(load "cglue.scm")
(load "hashfns.scm")

(load "classes.scm")
(load "strtable.scm")
(load "strcitable.scm")
(load "symtable.scm")
(load "eqtable.scm")
(load "objtable.scm")
(load "gentable.scm")
(load "misc.scm")
(load "make.scm")
(load "tablemap.scm")

(load "init.scm")
