/*
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
*/
#include "tables_p.h"

/* Link file for the tables module */

#define NUM_ROOTS (6)
obj tables_root_vector[NUM_ROOTS];

#ifdef PROVIDE_ROOT_NAMES
static struct root_info roots[] = {
    { 1, "<table-bucket>" },
    { 0, "<table>" },
    { 2, "<string-table>" },
    { 3, "<string-ci-table>" },
    { 4, "<eq-table>" },
    { 5, "<object-table>" },
    { 0, NULL } };
#else /* PROVIDE_ROOT_NAMES */
#define roots ((struct root_info *)0)
#endif /* PROVIDE_ROOT_NAMES */
extern struct part_descr tables_part_cglue;
extern struct part_descr tables_part_hashfns;
extern struct part_descr tables_part_strtable;
extern struct part_descr tables_part_strcitable;
extern struct part_descr tables_part_symtable;
extern struct part_descr tables_part_eqtable;
extern struct part_descr tables_part_objtable;
extern struct part_descr tables_part_gentable;
extern struct part_descr tables_part_misc;
extern struct part_descr tables_part_make;
extern struct part_descr tables_part_tablemap;
extern struct part_descr tables_part_init;

static struct part_descr *(tab[]) = {
    &tables_part_cglue,
    &tables_part_hashfns,
    &tables_part_strtable,
    &tables_part_strcitable,
    &tables_part_symtable,
    &tables_part_eqtable,
    &tables_part_objtable,
    &tables_part_gentable,
    &tables_part_misc,
    &tables_part_make,
    &tables_part_tablemap,
    &tables_part_init,
    NULL };
struct module_descr module_tables = { "tables", tab,
	NUM_ROOTS, /* num_roots */
	tables_root_vector,
	roots};

