#|
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
|#
(%use os)

(define *sleep-list* '())

(define (add interval x)
    (if (number? interval)
	(set! interval (seconds->interval interval))
	(type-check interval interval? <interval>))
    (set! *sleep-list* 
	    (cons (cons (time+ (time-now) interval)
			x)
		*sleep-list*)))
  
(define (strip)
  (let ((now (time-now)))
    (let loop ((i *sleep-list*) (prev #f))
      (if (not (null? i))
	  (if (time>=? now (caar i))
	      (begin
		(format #t "ready: ~s\n" (car i))
		(if prev
		    (set-cdr! prev (cdr i))
		    (set! *sleep-list* (cdr i)))
		(loop (cdr i) prev))
	      (loop (cdr i) i)))))
  (format #t "left: ~s\n" *sleep-list*))


