#|
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
|#
#|**************************** <weak-cell> ****************************|#

(define-class <weak-cell> (<Object>) :no-ivar-gfs :weak1
    contents)

(define (weak-cell value)
    (%make <weak-cell> value))

(define (contents wc)
    (let ((v (%gvec-read wc 0)))
	(if (eq? v '#unbound)
	    (values #f #f)
	    (values v #t))))

(define (set-contents! wc v)
    (%gvec-write wc 0 v)
    v)

(export <weak-cell>
        weak-cell contents set-contents!)

#|**************************** <weak-pair> ****************************|#

(define-class <weak-pair> (<Object>) :no-ivar-gfs :weak1
    car
    cdr)

(define (weak-cons car cdr)
    (%make <weak-pair> car cdr))

(define weak-car contents)

(define (weak-cdr wp)
    (%gvec-read wp 1))

(export <weak-pair> weak-cons weak-car weak-cdr)
