#|
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
|#
;;  File for measuring the amount of allocation
(%use hacker)

(define *classes-of-interest*
  (list <bindingenvt>
	<closure>
	<pair>
	<vector>
	<string>
	<longfloat>
	<symbol>
	<<class>>
	<partialcontinuation>))

(define (get-allocation-info class)
  (vector class
	  (%gvec-read class 20)
	  (%gvec-read class 21)))

(define (reset-allocation-info class)
  (%gvec-write class 20 0)
  (%gvec-write class 21 0))

(define (print-allocation-info info)
  (format #t "~a\t~d objects for ~d bytes\n" 
	  (class-name (vector-ref info 0))
	  (vector-ref info 1)
	  (vector-ref info 2)))

(define (with-allocation-info thunk)
  (for-each reset-allocation-info *classes-of-interest*)
  (reset-allocation-stats)
  (let* ((result (thunk))
	 (total (allocation-stats))
	 (alloc-info (map get-allocation-info *classes-of-interest*)))
    (for-each
     print-allocation-info 
     alloc-info)
    (format #t "Total allocation ~d objects for ~d bytes\n"
	    (vector-ref total 1)
	    (vector-ref total 0))
    result))
