#|
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
|#
;; This file illustrates the use of dynamic loading
(%use dynamic-linking pathname)
;(load "/tmp/xx")

(define (image m)
    (apply append (map templates (files m))))

(define (ld opath m)
    (dynamic-load-code (pathname->string opath) 
		       (vector (symbol->string (name m))
			       (image m))
		       (name m)))

(define (module->ofile m)
    (make <file-name> directory: (dest-dir m)
    		      filename: (string-append (symbol->string (name m))
		     			       "_m")
		      extension: "o"))

#|
(define *CFLAGS*
  (string-append 
    "\"_CFLAGS=-g -Wall -pipe -DUSE_HW_REGS -DSTACK_CACHE"
    "  -O2 -DRECORD_CALL_CHAIN -DINLINES"))

(define *IFLAGS* 
    (string-append 
	" -I. -I.. -I../runtim -I../hasht -I../heapi"
	" -I../freelist -I../builtins_m -I../unxlib_m\""))
|#
(define *FLAGS* (file->string "flags"))
(let ((n (string-length *FLAGS*)))
  (if (eq? (string-ref *FLAGS* (sub1 n)) #\newline)
      (set! *FLAGS* (substring *FLAGS* 0 (sub1 n)))))

(define (id x) x)

(define (system-make m)
    (system (string-append
		"cd "
		(pathname->string (dest-dir m))
		" ; make \"" *FLAGS* "\""
		" CC=g++")))

(define (in m)
    (fluid-let ((*warn-unbound-var-ref* #t))
	(update m))
    (if (not (eq? (system-make m) 0))
	(abort 'in/system-make "making ~s" m))
    (if (not (fork))
	(begin
	    (set! *shadows* '())
	    (read-eval-print
		(top-level-envt m)
		(ld (module->ofile m) m))
	    (%exit 0))
	(display "Back to outer process\n")))


