#|
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
|#
;; functionality like that of unix's "find"

(%use os pathname)

(define (safe-stat path)
    (call-with-current-continuation
	(lambda (exit)
	    (fluid-let ((*exception* (lambda args (exit #f))))
		(stat path)))))

(define (for-each-file path file-proc dir-proc)
    ;(format #t "Checking ~a\n" path)
    (for-each
	(lambda (d)
	    (let* ((f (string-append path "/" d))
		   (s (safe-stat f)))
		(if s
		    (if (stat-directory? s)
			(if (dir-proc f)
			    (for-each-file f file-proc dir-proc))
			(file-proc f)))))
	(sort (cddr (scandir path)) string<?)))
