#|
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
|#
;#!/u/TKG/bin/rs -script
;; this is a script that creates a new bootable image /tmp/foo.img
;; which starts up in the friendly (syntax-checked) envt.

(%use pathname eval)
(%use os)

(define (top-level-envt? envt)
  (instance? envt <toplevelenvt>))

(define (envt-bound? envt name)
  (and (envt-binding-of envt name) #t))

(define (envt-binding-of envt name)
  (type-check name symbol? <symbol>)
  (type-check envt top-level-envt? <toplevelenvt>)
  (lookup envt name))

(load "saveimag.scm")
(load "syntaxch.scm")

(define repl-interrupt (vector-ref exception-vector 0))

;; this is a function to replace
;; the $start function in repl/start.scm

(define ($new-start args)
  (fluid-let ((*exception* (lambda args 
			     (write args)
			     (newline)
			     (display "bye bye\n"))))
    (vector-set! exception-vector 0 repl-interrupt)
    (let ((envt (make-default-envt)))
      (set-syntax-checker! (lookup envt 'define-class) 
			   check-define-class-syntax)
      (set-syntax-checker! (lookup envt 'define-method) 
			   check-define-method-syntax)
      (fluid-let ((*top-level-envt* envt)
		  (*current-dir* (string->dir "."))
		  (*warn-unbound-var-ref* #f)
		  (*HOME* (string->dir (or (getenv "HOME") "."))))
	(read-eval-print envt "friend")))))
#|
(define ($new-start args)
  (write args)
  (newline)
  (%exit 0))
|#
(display "Saving new image...\n")

(save-image "/tmp/foo.img"
	    "Friendly environment (v0.1)"
	    $new-start)


