#|
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
|#
(%use os pathname)
;(load "../unxlib/unixutil.scm")

(define (safe-stat path)
    (call-with-current-continuation
	(lambda (exit)
	    (fluid-let ((*exception* (lambda args (exit #f))))
		(stat path)))))
		

(define (check name main ext)
    (let ((p (string->file name)))
	(if (> (string-length (filename p)) main)
	    (format #t "  name too long: ~a\n" name)
	    (if (and (extension p)
	    	     (> (string-length (extension p)) ext))
		(format #t "  extension too long: ~a\n" name)))))
    
(define (msdos-check path)
    (format #t "Checking ~a\n" path)
    (let ((subs '()))
	(for-each
	    (lambda (d)
		(let* ((f (string-append path "/" d))
		       (s (safe-stat f)))
		    (if s
			(begin
			    (check d 8 3)
			    (if (stat-directory? s)
				(set! subs (cons f subs)))))))
	    (cddr (scandir path)))
	(for-each msdos-check subs)))

    
;(msdos-check ".")
;(%exit 0)
