#|
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
|#
;; a version of load that you can reload changed files

(%use pathname os)

(define reload #f)

(define load
  (let ((basic-load load)
	(load-times '()))
    (set! reload
	  (lambda ()
	    (for-each
	     (lambda (l)
	       (let* ((p (caddr l))
		      (t (vector-ref (stat p) 1)))
		 (if (time>? t (cadr l))
		     (begin
		       (set-car! (cdr l) t)
		       (fluid-let ((*reload* p))
			 (basic-load p))))))
	     load-times)
	    (values)))
    (lambda 'load (path)
      (if (fluid-ref *reload* #f)
	  (values)
	  (let ((t (assoc path load-times)))
	    (if t
		(set-car! (cdr t) (vector-ref (stat (caddr t)) 1))
		(let ((p&f (locate (fluid-ref *current-dir*)
				   (fluid-ref *search-path* '())
				   '("scm")
				   path)))
		  (if p&f
		      (let ((p (pathname->string (cdr p&f))))
			(close-input-port (car p&f))
			(set! load-times 
			      (cons (list path
					  (vector-ref (stat p) 1)
					  p)
				    load-times))))))
	    (basic-load path))))))
    