#|
Copyright (C) 1994  Donovan Kolbly, Paul Wilson

This file is part of RScheme (v0.5.0, 94.12.31)

This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as
published by the Free Software Foundation

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author may be reached at Donovan.Kolbly@TKG.com
or dkolbly@cs.utexas.edu or c/o wilson@cs.utexas.edu
|#
(define (failed sexpr)
  (format #t "expression failed: ~s\n" sexpr))

(define-syntax (verify . things)
  (letrec-syntax ((verify-1 (syntax-form (thing)
			        (if (not thing)
				    (failed (mquote thing)))))
		  (verify-n (syntax-form ())
			    (syntax-form (thing . more-things)
				(verify-1 thing)
				(verify-n . more-things))))
    (verify-n . things)))

(verify (exact? (expt 2 28))
	(exact? (expt -2 29))
	(inexact? (expt 2 29)))

(verify (= (round (expt 2 10.0)) (expt 2 10))
	(= (round (expt 2 30.0)) (expt 2 30))
	(integer? (expt 2 30.0)))

(verify (equal? (map cons '(1 2 3) '(x y . z))
		'((1 . x) (2 . y))))

;; R4RS p.22

(verify (inexact? (round 3.0))
	(exact? (inexact->exact 3.0)))
